;******************************************************************************
; 			      ULTRAPASCAL LIBRARY
;------------------------------------------------------------------------------
; The library, which includes the most required procedures
; and the exception handlers for UltraPascal
;
; Documentation: Ultra Pascal/doc/paslib.txt
;
; released by MXM Projects
; http://start.at/mxm
;
; created by MXM-TriX
; mxmtrix@xoommail.com
;
; Version		0.7.2.1
; for 			UltraPascal		V0.1.31
;			Fargo II		0.2.7.1
; Last update   	24091998
;
; PASLIB is the same as in Fargo Pascal ( some more features ).
; I generally use C/C++ for prototypes of a function, for better
; understanding etc.
;******************************************************************************

	include "tios.h"
        include "gray4lib.h"
	include "flib.h"
        xdef _library
;	xdef _ti92plus
;	xdef _ti89
        xdef paslib@0000
	xdef paslib@0001
        xdef paslib@0002
        xdef paslib@0003
        xdef paslib@0004
        xdef paslib@0005
	xdef paslib@0006
	xdef paslib@0007
	xdef paslib@0008
	xdef paslib@0009
	xdef paslib@000A
	xdef paslib@000B
	xdef paslib@000C
	xdef paslib@000D
	xdef paslib@000E
	xdef paslib@000F
	xdef paslib@0010

;------------------------------------------------------------------------------
; void put_sprite ( void *spr_tbl, int sprnr, int x_coor, int y_coor );
; spr_table		-> a0
; sprnr			-> d2
; x_coor		-> d0
; y_coor		-> d1
;
; This procedure puts a sprite to the screen, by using the 'MOVE'.
; Routine from Jimmy Mardell.
; Gray4lib has to be active!
;------------------------------------------------------------------------------

paslib@0000:
put_sprite:

 movem.l d0-d3/a0-a2,-(a7)
 sub.w   #1,d2
 lsl.l   #6,d2
 adda.l  d2,a0
 lsl.w   #1,d1
 move.l  d1,d2
 lsl.w   #4,d2
 sub.w   d1,d2
 move.b  d0,d1
 and.w   #$FFF0,d0
 lsr.b   #3,d0
 add.w   d0,d2
 and.b   #$0F,d1
 sub.b   #16,d1
 neg     d1
 moveq   #15,d0
 move.l  gray4lib::plane1,a1
 move.l  gray4lib::plane0,a2
 adda.l  d2,a1
 adda.l  d2,a2
PS_PutRow:
 clr.l   d2
 move.w  (a0)+,d2
 lsl.l   d1,d2
 eor.l   d2,(a1)
; EOR is faster and secondly better for sprites
 clr.l   d2
 move.w  (a0)+,d2
 lsl.l   d1,d2
 eor.l   d2,(a2)
 lea     30(a1),a1
 lea     30(a2),a2
 dbra    d0,PS_PutRow
 movem.l (a7)+,d0-d3/a0-a2
 rts

;------------------------------------------------------------------------------
; void put_sprite_move ( void *spr_tbl, int sprnr, int x_coor, int y_coor );
; spr_table		-> a0
; sprnr			-> d2
; x_coor		-> d0
; y_coor		-> d1
;
; This procedure puts a sprite to the screen, by using the 'MOVE'.
; Routine from Jimmy Mardell.
; Gray4lib has to be active!
;------------------------------------------------------------------------------

paslib@0001:
put_sprite_move:

 movem.l d0-d3/a0-a2,-(a7)
 sub.w   #1,d2
 lsl.l   #6,d2
 adda.l  d2,a0
 lsl.w   #1,d1
 move.l  d1,d2
 lsl.w   #4,d2
 sub.w   d1,d2
 move.b  d0,d1
 and.w   #$FFF0,d0
 lsr.b   #3,d0
 add.w   d0,d2
 and.b   #$0F,d1
 sub.b   #16,d1
 neg     d1
 moveq   #15,d0
 move.l  gray4lib::plane1,a1
 move.l  gray4lib::plane0,a2
 adda.l  d2,a1
 adda.l  d2,a2
 move.l  #$FFFF0000,d3
 rol.l   d1,d3
PS_PutRow_move:
 clr.l   d2
 move.w  (a0)+,d2
 lsl.l   d1,d2
 and.l   d3,(a1)
 or.l    d2,(a1)
 clr.l   d2
 move.w  (a0)+,d2
 lsl.l   d1,d2
 and.l   d3,(a2)
 or.l    d2,(a2)
 lea     30(a1),a1
 lea     30(a2),a2
 dbra    d0,PS_PutRow_move
 movem.l (a7)+,d0-d3/a0-a2
 rts


;------------------------------------------------------------------------------
; long pascal_mod ( long par1, long par2 );
; par1		-> pascalstack
; par2		-> pascalstack
; return	-> pascal_return
;
; This is the MOD function
; First idea from Rafael H. Padilla, but since remainder has to fit in
; 16bit with his routine, UltraPascal takes the TIOS routine, which doesn't
; care this problem
;------------------------------------------------------------------------------

paslib@0002:
__pascal_mod:
  movem.l a0,-(a7)
  movem.l d0-d7/a0-a6,-(a7)
  move.l (a6)+,d0
  move.l (a6)+,d1

; Division by Zero will terminate the program!
; This part is detected by the internal exceptionhandlers, so here isn't any
; test necessary
; Use TIOS routine

  jsr tios::_rs32s32
  move.l d1,__pascal_temp_variable
  movem.l (a7)+,d0-d7/a0-a6
  lea 8(a6),a6
  move.l __pascal_func_result,a0
  move.l __pascal_temp_variable,(a0)
  movem.l (a7)+,a0
  rts

;*****************************************************************************
; 		INTERNAL PROCEDURES FROM ULTRAPASCAL
;-----------------------------------------------------------------------------
; This routines aren't exported to UltraPascal, because for beginners they
; are a very critical section and wrong handling can cause a TI92 crash!
; Look at PASLIB.DOC for some infos
;*****************************************************************************

;------------------------------------------------------------------------------
; void ShowError ();
; Display errorstring[__exception_code] and waits for a key
;------------------------------------------------------------------------------

ShowError:

        jsr flib::zap_screen
	move.w #1,-(a7)
	jsr tios::FontSetSys
	lea 2(a7),a7

	move.w #4,-(a7)
	pea __exception_show_error(PC)
	move.w #53,-(a7)
	clr.w -(a7)
	jsr tios::DrawStrXY
	lea 10(a7),a7

        move.w __exception_code,-(a7)
	move.l __exception_at,-(a7)
	pea __exception_format_string(PC)
	pea __exception_output_string(PC)
	jsr tios::sprintf
	lea 14(a7),a7

	move.w #4,-(a7)
	pea __exception_output_string(PC)
	move.w #63,-(a7)
	clr.w -(a7)
	jsr tios::DrawStrXY
	lea 10(a7),a7


	move.w __exception_code,d0
	sub.w #1,d0
	lea exception_table(PC),a0
	move.l a0,a1
	lsl.w #2,d0
	move.l 0(a0,d0.w),a0
	adda.l a0,a1
	
	move.w #4,-(a7)
	move.l a1,-(a7)
	move.w #73,-(a7)
	clr.w -(a7)
	jsr tios::DrawStrXY
	lea 10(a7),a7
	
	jsr flib::idle_loop
	rts


;------------------------------------------------------------------------------
; void *register_pascal_program (unsigned int stacksize, void *exception_at);
; stacksize 	-> d0
; exception_at  -> a5
; func_result   -> a4
; This section is for initializing a pascal program.
; It returns the address to the Pascalstack. The function adds four bytes for
; the return function ( Result in A6 )
; This could be also done by BSS, but Fargo I programs doesn't have that.
;------------------------------------------------------------------------------

paslib@0003:
register_pascal_program:

  move.l a4,__pascal_func_result
  move.w d0,__pascal_stack_size
  sub.w #4,__pascal_stack_size		; Pointer to the saved a7 in the stack
  move.w d0,d1
  ext.l d0
  movem.l d1-d7/a0-a6,-(a7)
  move.l d0,-(a7)
  jsr tios::HeapAlloc
  lea 4(a7),a7
  move.w d0,__pascal_stack_handle
  movem.l (a7)+,d1-d7/a0-a6
  move #0,a0
  tst.w d0
  beq _next_init_step
  tios::DEREF d0,a6
  lea 0(a6,d1.w),a6
_next_init_step:
  move.l a6,__pascal_stack
  move.l a5,__saved_proc_exception
  clr.w __exception_code

  bsr DisableTry  			; Disable the 'TRY'
  bsr InitMemoryManager			; Heap-Manager initializing sequence

; Install exception handlers
  move.w #$700,d0
  trap #1
  bclr.b #2,$600001
  moveq #47,d1
  move #0,a0
  lea exception_original_addresses,a1
_copy_original_addresses:
  move.l (a0)+,(a1)+
  dbra d1,_copy_original_addresses

; Install own exception handlers

  move.l #_div_0_exception,($14)	; Division by Zero
  move.l #_address_exception,($C)	; Address error
  move.l #_illegal_exception,($10)	; Illegal instruction
  move.l #_privilege_exception,($20)	; Privilege violation
  move.l #_line1010_exception,($28)	; Line 1010 emulator
  move.l #_line1111_exception,($2C)	; Line 1111 emulator

  bset.b #2,$600001
  trap #1

  move.l __pascal_stack,a6
  rts

;------------------------------------------------------------------------------
; void handle_pascal_exceptions ();
;
; This section is always called to terminate the program and also to handle
; exception, when an interrupt happen.
;------------------------------------------------------------------------------

paslib@0004:
__handle_pascal_exceptions:
; In	Nothing
; Out	Nothing, program will terminate!
; This routine is called to terminate the program and to restore the TI92 state

  bsr DisableMemoryManager
  bsr unregister_pascal_program

  move.w __exception_code,d1

  tst.w d1
  beq _no_exception
  
  bsr ShowError
  bra _no_exception

_no_exception:

  move.l __pascal_stack,a6
  lea -4(a6),a6
; Back to the TI92
  rts

;------------------------------------------------------------------------------
; void unregister_pascal_program ();
;
; This section deinstall all exception handlers, ...
;------------------------------------------------------------------------------

paslib@0005:
unregister_pascal_program:
; Unregister the pascalprogram and deinstall all handlers

; Deinstall all exception handlers

  move.w #$700,d0
  trap #1
  bclr.b #2,$600001
  
  lea exception_original_addresses,a0
  moveq #47,d1
  move.l #0,a1

_restore_original_ints:
  move.l (a0)+,(a1)+
  dbra d1,_restore_original_ints
  
  bset.b #2,$600001
  trap #1

  move.w __pascal_stack_handle,-(a7)
  jsr tios::HeapFree
  lea 2(a7),a7
  rts

;------------------------------------------------------------------------------
; void EnableTry (void *Error_Address);
; Error_Address  -> a3
;
; This procedure enables the TRY instruction from UltraPascal. 
; We just set a new exceptionaddress. This address is in the ELSE part of
; the TRY.
;------------------------------------------------------------------------------

paslib@0006:
EnableTry:
	move.l __pascal_proc_exception,__saved_proc_exception
	move.l a3,__pascal_proc_exception
	rts

;------------------------------------------------------------------------------
; void DisableTry ();
;
; This procedure disables the TRY instruction
;------------------------------------------------------------------------------
paslib@0007:
DisableTry:
	move.l __saved_proc_exception,__pascal_proc_exception
	clr.l __exception_code
	rts

;*****************************************************************************
;			EXCEPTIONHANDLERS FROM ULTRAPASCAL
;-----------------------------------------------------------------------------
; This part is a critical area. If you are a beginner, don't modify anything,
; else we take no liabality, if your TI92 crashs
; 
; Here are all interrupthandlers and some internal procedures!
;
; Exceptionprincip:
; When an exception happens, then this procedures restore the state of the 
; TI92. It's a very simple technique. We just modify the stack and return of
; the interrupt. Since in interrupts we can't access any text functions, any
; UltraPascal program requires a exception section ( this could be probably
; programable in future ).
;*****************************************************************************


_div_0_exception:

; This is the routine for the division by zero trap.

  move.b #1,__exception_code+1
  bra restore_ti92_state

_address_exception:
  move.b #2,__exception_code+1
  bra restore_ti92_state

_privilege_exception:
  move.b #3,__exception_code+1
  bra restore_ti92_state

_chkv_exception:
  move.b #4,__exception_code+1
  bra restore_ti92_state

_trapv_exception:
  move.b #5,__exception_code+1
  bra restore_ti92_state

_line1010_exception:
  move.b #6,__exception_code+1
  bra restore_ti92_state

_line1111_exception:
  move.b #7,__exception_code+1
  bra restore_ti92_state

_illegal_exception:
  move.b #8,__exception_code+1
  bra restore_ti92_state

_other_exceptions:

; Here are other exceptions, but they are just to avoid the crash of the calc

  move.b #9,__exception_code+1

; Other exceptions for the future

; This is the real critical section of all exception handlers!

restore_ti92_state:
	
; Call the exception routine from the pascalprogram
; UltraPascal supports the 'TRY' instruction, but it seems, that somewhere
; is a bug, when Try_enabled is TRUE.

	move.l 2(a7),__exception_at
	move.l __pascal_proc_exception,2(a7)
	rte
	

;******************************************************************************
;			MEMORYHANDLING SYSTEM
;------------------------------------------------------------------------------
;
; Here is the memoryhandling of UltraPascal memory
;------------------------------------------------------------------------------


;------------------------------------------------------------------------------
; void InitMemoryManager ()
;
; This routine is called from the registerprogram. It initializes the memory
; for the own table.
;------------------------------------------------------------------------------

InitMemoryManager:

	movem.l d0-d7/a0-a6,-(a7)

	lea memsystem_table,a0

	move.w #24,d0
_clear_table:
	clr.w (a0)+
	dbra.w d0,_clear_table

	movem.l (a7)+,d0-d7/a0-a6
	rts

;------------------------------------------------------------------------------
; void DisableMemoryManager ();
;
; Shut down the memory manager
;------------------------------------------------------------------------------
DisableMemoryManager:
	movem.l d0-d7/a0-a6,-(a7)

	lea memsystem_table,a0
	move.w #24,d0

__free_memory_loop:
	move.w (a0)+,d1
	tst.w d1
	beq _next_memory_loop
	movem.l d0-d7/a0-a6,-(a7)
	move.w d1,-(a7)
	jsr tios::HeapFree
	lea 2(a7),a7
	movem.l (a7)+,d0-d7/a0-a6
_next_memory_loop:
	dbra.w d0,__free_memory_loop	

	movem.l (a7)+,d0-d7/a0-a6
	rts

;------------------------------------------------------------------------------
; void *getmem (long size);
; size		-> d0
; return	-> a4
;
; Allocates memory
;------------------------------------------------------------------------------

paslib@0009:
getmem:
	move.l d0,malloc_size
	movem.l d0-d7/a0-a3/a5-a6,-(a7)

	lea memsystem_table,a0

	move.w #24,d0

_find_entry:
	tst.w (a0)
	beq __founded_entry
	lea 2(a0),a0
	dbra.w d0,_find_entry

	movem.l (a7)+,d0-d7/a0-a6
	clr.l (a4)
	rts

__founded_entry:
	movem.l a0,-(a7)
	move.l malloc_size,-(a7)
	jsr tios::HeapAlloc
	lea 4(a7),a7
	movem.l (a7)+,a0
	move.w d0,(a0)
	tios::DEREF d0,a4
	movem.l (a7)+,d0-d7/a0-a3/a5-a6
	rts

;------------------------------------------------------------------------------
; void freemem (void *free_ptr);
; free_ptr	-> D0
;
; Frees the memory, used by FREE_PTR
;------------------------------------------------------------------------------
paslib@000A:
freemem:
	movem.l d0-d7/a0-a6,-(a7)
	tios::DEREF d0,a0
	cmpa.l #0,a0
	beq __done_freemem

	lea memsystem_table,a1
	move.w #24,d0

_find_handle:
	move.w (a1)+,d3
	move.w d3,d4
        beq __freemem_loop      
	tios::DEREF d3,a3
	cmpa.l a3,a0
	beq __free_mem
__freemem_loop:
	dbra.w d0,_find_handle
__done_freemem:
	movem.l (a7)+,d0-d7/a0-a6
	rts

__free_mem:
	lea -2(a1),a1
	clr.w (a1)
	move.w d4,-(a7)
	jsr tios::HeapFree
	lea 2(a7),a7
	bra __done_freemem


;******************************************************************************
;			Stringhandlingroutine
;------------------------------------------------------------------------------
; New since 21081998
; This routine is used for Stringmanipulation, instead of the tios::StrCat
; routine, to get compacter code
;------------------------------------------------------------------------------

;------------------------------------------------------------------------------
; void strcat ( char *destination, unsigned int max_length, char *string_1,
;               char *string_2, ..., work_mode )
; All parameters are pushed to the stack from the left to the right
; ( PASCALSTACK A6 )
; One special:
; NUMBER_STRINGS contain in the low byte the temp_string [ x ] and in the
; high byte the max string length.
;------------------------------------------------------------------------------

paslib@000B:
strcat:
; Push the saved registers to 
     movem.l d0-d7/a0-a3,-(a7)
     move.w 4(a6),d0
     lea temp_string_1,a0
     clr.w d1    ; Counter for the stringlength
     clr.w d2
     move.b d0,d2
     lsr.w #8,d0
     tst.w d0
     bne load_temp_string_2
     lea temp_string_1,a0
     bra init_next_step
load_temp_string_2:
     lea temp_string_2,a0
init_next_step:
     move.l a0,a3
     sub.w #1,d2
     moveq #6,d3                   ; First offset to the stack
string_add:
     move.w 0(a6,d3.w),d4
     cmp.w #$fffe,d4
     bcc move_string
     movea.l 0(a6,d3.w),a1
;     cmpa.l #$10000000,a1
;     bcs string_move
; Just add a char to the string ( in work )
;     move.l a1,d4
;     rol.l #8,d4
;     and.w #$00FF,d4
;     suba.l #$10000000,a1
;     move.b 0(a1,d4.w),(a0)
;     add.w #1,d1
;     bra string_loop_control
string_move:
     tst.b (a1)
     beq string_loop_control
     move.b (a1)+,(a0)+
     add.w #1,d1
     cmp.w d1,d2
     beq move_string
     bra string_move
string_loop_control:
     add.w #4,d3
     cmp.w d1,d2
     bne string_add
move_string:
     clr.b (a0)
     cmp.w #$fffe,d4
     beq end_strcat
     move.l a3,a0
     movea.l (a6),a1
move_string_loop:
     move.b (a0)+,(a1)+
     tst.b (a0)
     bne move_string_loop
     clr.b (a1)
end_strcat:
     clr.b (a1)
     lea 6(a6),a6
find_a6_end:
     move.w (a6)+,d0
     cmp.b #$fe,d0
     bcs find_a6_end
     lea -2(a6),a6
     movem.l (a7)+,d0-d7/a0-a3
     rts

;******************************************************************************
; Stringcompare
;------------------------------------------------------------------------------
; void strcmp ( char *str_1, char *str_2 )
; PASCALSTACK
; Compares two strings and set the result in the registers

paslib@000C:
strcmp:
    movem.l d1-d7/a0-a6,-(a7)
    moveq #1,d1
get_lbl:
    move.l (a6)+,a0
    cmpa.l #$ffffffff,a0
    beq put_temp_string_1
    cmpa.l #$fffffffe,a0
    beq put_temp_string_2
    move.l a0,-(a7)
    bra loop_lbl
put_temp_string_1:
    pea temp_string_1
    bra loop_lbl
put_temp_string_2:
    pea temp_string_2
loop_lbl:
    dbra d1,get_lbl
    jsr tios::strcmp 
    lea 8(a7),a7
    movem.l (a7)+,d1-d7/a0-a6
    rts

;******************************************************************************
; UltraPascal function handling
;------------------------------------------------------------------------------
; Here PASLIB offers two functions, for supporting functionresults, which
; are bigger than 4 bytes
;------------------------------------------------------------------------------

; void find_level_space ();
find_level_space:
  lea prev_levels,a0
  moveq #4,d0
\tst_loop:
  tst.l (a0)+
  dbra d0,\tst_loop
  rts
 
; void StartNewFuncLevel();
paslib@000D:
StartNewFuncLevel:
  bsr find_level_space
  clr.l (a0)
  move __pascal_curr_func_lvl,-(a0)
  rts

; void AllocMergeLevel();
; In		__pascal_func_result	-> Pointer to the area
;		d7			-> size ( bytes )
paslib@000E:
MoveArea:
  move.l __pascal_curr_func_lvl,a0
  move.l __pascal_func_result,a1
  move.l a0,__pascal_last_func_lvl
\copy:
  move.b (a1)+,(a0)+
  dbra d7,\copy
  move.l a0,__pascal_curr_func_lvl
  rts

; void MergeFuncLvl();
paslib@000F:
MergeFuncLvl:
  bsr find_level_space
  move.l -(a0),__pascal_curr_func_lvl
  clr.l (a0)
  rts

paslib@0010:
MergeLast:
  move.l __pascal_last_func_lvl,__pascal_curr_func_lvl
  rts

;******************************************************************************
;				VARIABLES
;------------------------------------------------------------------------------

malloc_size			dc.l 0

__pascal_proc_exception		dc.l 0
__saved_proc_exception		dc.l 0
__pascal_stack                  dc.l 0
__pascal_stack_handle		dc.w 0
__pascal_stack_size		dc.w 0
__pascal_temp_variable		dc.l 0
__pascal_func_result		dc.l 0
__pascal_curr_func_lvl		dc.l 0
__pascal_last_func_lvl		dc.l 0


paslib@0008:
__exception_code		dc.l 0
__exception_at			dc.l 0

exception_table		dc.l (__division_exception-exception_table),
			dc.l (__address_exception-exception_table),
			dc.l (__privilege_exception-exception_table),
			dc.l (__chkv_exception-exception_table),
			dc.l (__trapv_exception-exception_table),
			dc.l (__line1010_exception-exception_table),
			dc.l (__line1111_exception-exception_table),
			dc.l (__illegal_exception-exception_table),
			dc.l (__unknown_exception-exception_table)

__exception_show_error		dc.b "UltraPascal exception",0
__exception_format_string	dc.b "at %08lX, exceptioncode %d",0
__exception_output_string	dc.b "                                ",0

__division_exception            dc.b "Division by Zero exception!",0
; Code	1

__address_exception		dc.b "Address Error exception!",0
; Code	2

__privilege_exception		dc.b "Privilige violation exception!",0
; Code	3

__chkv_exception		dc.b "CHKV exception!",0
; Code	4

__trapv_exception		dc.b "TRAPV exception!",0
; Code 5

__line1010_exception		dc.b "Line 1010 exception!",0
; Code 6

__line1111_exception		dc.b "Line 1111 exception!",0
; Code 7

__illegal_exception		dc.b "Illegal instruction",0
; Code 8

__unknown_exception		dc.b "Unknown exception code!",0
; Code 9


_library                        dc.b "paslib",0

	BSS

exception_original_addresses	ds.l 48
memsystem_table			ds.w 25
temp_string_1			ds.b 50
temp_string_2			ds.b 50
temp_func_space			ds.b 150
; TEMP_FUNC_SPACE is a buffer for functionresults, which are bigger than
; 4 bytes ( so a pointer is returned )
prev_levels			ds.b 20
; Previous levels are used for functionhandling
        END