
{

 UltraPascal File cache object

 Used for units ( faster reading )
}

unit upas_ch;

interface

type
      file_operations = ( _rewrite, _reset, _append );
      pcache = ^cache;
      cache = object
        constructor init ( fn: string; rewrite_bool: boolean );
        procedure cacheread ( var p; size: word ); virtual;
        procedure cachewrite ( var p; size: word ); virtual;
        function  filename : string;
        procedure fileclose;
        function fileeof: boolean;
        destructor done;
      private
        cache_f  : file;
        cache_fn : string;
        cache_pos: integer;
        cache_ptr: pointer;
        cache_size: word;
	file_name: string;
      end;

implementation

constructor cache.init;
begin
 cache_pos := 0;
 file_name := fn;
 cache_fn := fn;
 cache_ptr := ptr ($1234, $5678);
 assign ( cache_f, fn );
 case rewrite_bool of
  true      : begin
              rewrite ( cache_f, 1 );
              cache_ptr := nil;
             end;
{  _append  : begin
              reset ( cache_f, 1 );
              seek ( cache_f, filesize ( cache_f ));
              cache_ptr := nil;
             end;}
  false     : begin
	      reset (cache_f, 1); 	
              cache_size := filesize ( cache_f );
	      getmem (cache_ptr, cache_size);
	      blockread (cache_f, cache_ptr^, cache_size);
	      close (cache_f);	
             end;
 end;
end;

function cache.filename;
begin
 filename := cache_fn;
end;

procedure cache.cacheread;
var f: file;
begin
 if cache_ptr <> nil then begin
    move (ptr (seg (cache_ptr^), ofs (cache_ptr^) + cache_pos)^, p, size);
    inc ( cache_pos, size );
 end;
end;

function cache.fileeof;
begin
 fileeof := cache_pos >= cache_size;
end;

procedure cache.cachewrite ( var p; size: word );
begin
 blockwrite ( cache_f, p, size );
end;

procedure cache.fileclose;
begin
 if cache_ptr = nil then begin
  close ( cache_f );
  assign ( cache_f, cache_fn );
  reset ( cache_f, 1 );
  getmem ( cache_ptr, filesize ( cache_f ));
  blockread ( cache_f, cache_ptr^, filesize ( cache_f ));
  close ( cache_f );
  cache_size := filesize ( cache_f );
 end;
 cache_pos := 0;
end;

destructor cache.done;
begin
 if cache_ptr <> nil then
  freemem ( cache_ptr, cache_size )
end;

end.