{
 Float conversion routine for UltraPascal

 created by                         Rafael H. Padilla
                                    dysup@mcsa.net.mx

 ported to UltraPascal              by MXM-TriX
                                    alexander.grutsch.htlr@schulen.vol.at

 released under the terms of        MXM Projects
                                    http://start.at/mxm
}

unit upas_fl;

interface

function convert_float_to_hexstr(r: real): string;

implementation

var
  strnum:string;

function BinToHex(a:string):string;
var      i,j   :integer;
    output,dig :string;
begin
  output:='';
  for i:=0 to 7 do
  begin
   dig:='';
   for j:=1 to 4 do
    dig:=dig + a[i*4+j];
   if dig = '0000' then output:=output+'0';
   if dig = '0001' then output:=output+'1';
   if dig = '0010' then output:=output+'2';
   if dig = '0011' then output:=output+'3';
   if dig = '0100' then output:=output+'4';
   if dig = '0101' then output:=output+'5';
   if dig = '0110' then output:=output+'6';
   if dig = '0111' then output:=output+'7';
   if dig = '1000' then output:=output+'8';
   if dig = '1001' then output:=output+'9';
   if dig = '1010' then output:=output+'a';
   if dig = '1011' then output:=output+'b';
   if dig = '1100' then output:=output+'c';
   if dig = '1101' then output:=output+'d';
   if dig = '1110' then output:=output+'e';
   if dig = '1111' then output:=output+'f';
  end;
  BinToHex:=output;
end;


Function AtoF32(strnum:string):string;

var
  code,exppos,expneg,i,caract    :integer;

  num, inte, frcc                :real;

  output,numtemp,expo,pint,pfrc  :string;

  ff32num                      :array [1..32] of char;


function ToBin(a:real):string;
var b,c:string;
      i:integer;
begin
 c:='';
 b:='';
 while int(a)<>0 do begin
   b:=b+chr(trunc((a/2-int(a/2))*2) + ord('0'));
   a:=int(a/2);
 end;
 for i:= length(b) downto 1 do
  c:=c+b[i];
 tobin:= c;
end;

function ToBinFrac(a:real):string;
var b,c :string;
    i   :integer;
begin
  b:='';
  i:=0;
  while (frac(a)<>0) and (i<65) do begin
    b:=b+chr(trunc(a*2)+ord('0'));
    a:=a*2-int(a*2);
  end;
  ToBinFrac:=b;
end;

function expfrac(a:string):integer;
var i :integer;
begin
  i:=1;
  while (a[i] = '0') and (i < length(a)) do inc(i);
  if (i-1) = length(a) then expfrac:=0 else expfrac:= i-1;
end;

begin
 fillChar(ff32num,SizeOf(ff32num),'0');
 fillchar(numtemp,SizeOf(numtemp),'0');
 Output:='';

 val(strnum, num, code);

 if code <> 0 then 
   AtoF32:='Bad number format'        
 else begin

  if num <> 0 then
    if (num > 0) then begin
       if (num < 5.42101070E-20) or (num > 9.22337177E18) then
         output := 'OverFlow';
      end
    else
      if (num > -2.71050535E-20) or (num < -9.22337177E18) then
         output := 'UnderFlow'
       else
         ff32num[25]:='1';

    if output='' then
    begin         
      num  := abs(num);   
      inte := int(num);
      frcc := num-inte;
                    
      PInt   := ToBin(inte);
      PFrc   := ToBinFrac(frcc);
      expPos := length(Pint);
      expNeg := expfrac(pFrc);
                        
      if length(PInt) = 0 then
        begin
          numtemp := pFrc;
          for i:= 1 to 24 do begin
            ff32num[i]:= numtemp[i+expneg];
          end
        end
      else
        begin
          numtemp := pInt + pFrc;
          for i:=1 to 24 do begin
            ff32num[i]:= numtemp[i];
          end;
        end;

      if expPos = 0 then
        caract := 64 - expneg
      else
        caract := 64 + exppos;
    
      Expo:=ToBin(caract);

      if caract <> 64 then begin
        if length(Expo)<7 then
          for i:= length(Expo) to 6 do
            Expo:= '0'+Expo;

        for i:=1 to 7 do
          ff32num[i+25]:= expo[i];
      end;
      AtoF32:=ff32num;
    end
    else
      AtoF32:=output;
  end;
end;

function convert_float_to_hexstr;
var s: string;
begin
  str (r, s);
  s := BinToHex(AtoF32(s));
  if not (s[1] in ['0'..'9','0'..'f']) then
   convert_float_to_hexstr := s
  else
   convert_float_to_hexstr := '$' + s;
end;

end.