
{

 UltraPascal inlinefunctions

 created by MXM-TriX            mxmtrix@xoommail.com
 released by MXM Projects       http://start.at/mxm

}

unit upas_inl{ine};

interface

const return_number = $100;
      return_code   = $200;
      return_reg    = $400;

type
      IC_PROC = procedure ( parameter_string: string );
      pinline_class = ^inline_class;
      inline_class = object
         constructor init ( name: string; create_code: IC_PROC; return_type: word );
         function get_return_code: word;
         function get_name: string;
         procedure gen_code ( par_str: string );
         destructor done;
      private
         func_name: string;
         call_proc: IC_PROC;
         return_var: word;
      end;


      pinline_list = ^inline_list;
      inline_list = record
              class : pinline_class;
              next : pinline_list;
      end;

      pcheck_class = ^check_class;
      check_class = object
         constructor init;
         procedure add_inline_func ( inline_obj: pinline_class );
         function check_inline_func ( func_name, parameter_string: string; needed_return_code: word) : boolean;
         destructor done;
      private
         first_inline_list: pinline_list;
         curr_inline_list: pinline_list;
      end;

var inline_class_object: pcheck_class;
    public_inline_number_result: word;
    public_stack_position : string;

implementation

uses upas_def, upas_str, upas_mat, upas_tk;

{ -->> Definition of the INLINE_CLASS >>--}
constructor inline_class.init;
begin
 func_name := name;
 call_proc := create_code;
 return_var := return_type;
end;

destructor inline_class.done;
begin
end;

function inline_class.get_name;
begin
 get_name := func_name;
end;

function inline_class.get_return_code;
begin
 get_return_code := return_var;
end;

procedure inline_class.gen_code;
begin
 call_proc ( par_str );
end;

{ -->> End of the INLINE_CLASS >>-- }


constructor check_class.init;
begin
 first_inline_list := nil;
 curr_inline_list := nil;
end;

destructor check_class.done;
var next: pinline_list;
begin
 curr_inline_list := first_inline_list;
 while curr_inline_list <> nil do begin
   next := curr_inline_list^.next;
   dispose ( curr_inline_list^.class, done );
   dispose ( curr_inline_list );
   curr_inline_list := next;
 end;
end;

procedure check_class.add_inline_func;
begin
 if curr_inline_list = nil then begin
  new ( curr_inline_list );
  first_inline_list := curr_inline_list;
 end else begin
  new ( curr_inline_list^.next );
  curr_inline_list := curr_inline_list^.next;
 end;
 curr_inline_list^.next := nil;
 curr_inline_list^.class := inline_obj;
end;

function check_class.check_inline_func;
var curr: pinline_list;
    s : string;
begin
 check_inline_func := false;
 curr := first_inline_list;
 while curr <> nil do begin
  s := upper_str ( curr^.class^.get_name );
  if (upper_str(s)=upper_str(func_name)) then begin
   if (curr^.class^.get_return_code and needed_return_code=0) then
    public_inline_number_result := $FFFF
   else begin
    check_inline_func := true;
    curr^.class^.gen_code ( parameter_string );
   end;
   exit;
  end;
  curr := curr^.next;
 end;
end;

{-->> INC inline function >>-- }
var inc_inline_class: pinline_class;

procedure inline_compile_inc ( parameter_string: string );
var calc_str : string;
    curr_par : string;
begin
 if parameter_string = '' then error_txt ( 'INC has got no effect' );
 curr_par := get_parameter ( parameter_string );
 calc_str := curr_par + ':=' + curr_par + '+(';
 if parameter_string <> '' then
  curr_par := get_parameter ( parameter_string )
 else
  curr_par := '1';
 calc_str := calc_str + curr_par + ');';
 compile_calculation ( calc_str, true );
end;

{-->> DEC inline function >>-- }
var dec_inline_class: pinline_class;

procedure inline_compile_dec ( parameter_string: string );
var calc_str : string;
    curr_par : string;
begin
 if parameter_string = '' then error_txt ( 'DEC has got no effect' );
 curr_par := get_parameter ( parameter_string );
 calc_str := curr_par + ':=' + curr_par + '-(';
 if parameter_string = '' then
  curr_par := get_parameter ( parameter_string )
 else
  curr_par := '1';
 calc_str := calc_str + curr_par + ');';
 compile_calculation ( calc_str, true );
end;

{ -->> SIZEOF operator >>-- }
var sizeof_inline_class: pinline_class;

procedure inline_compile_sizeof ( parameter_string: string );
var  p1: ppascal_var;
     index: integer;
begin
 index := data_type_index ( parameter_string );
 if index <> -1 then begin
  public_inline_number_result := variable_data_types[index].size;
  exit;
 end;
 p1 := get_pascal_var_descriptor ( parameter_string, local_first_variable );
 if p1 = nil then
  p1 := get_pascal_var_descriptor ( parameter_string, global_first_variable );
 if p1 = nil then
  error_txt ( 'Unkown type in "sizeof"');
 public_inline_number_result := p1^.size;
end;

{ -->> TYPECAST inline classes >>-- }
var inline_compile_typecast_word,
    inline_compile_typecast_byte: pinline_class;

procedure inline_compile_tc_word ( parameter_string: string );
var tmp_pos: string;
    tmp_reg: string;
begin
  tmp_pos := load_stack_position ( parameter_string );
  tmp_reg := get_freeregister;
  if find_size ( parameter_string ) > 2 then
   tmp_pos := conv_to_str ( 4 - find_size ( parameter_string )) + '+' + tmp_pos;
  output ( '  move.w '+tmp_pos+','+tmp_reg+#13#10+
           '  ext.l '+tmp_reg );
  public_stack_position := tmp_reg;
end;

procedure inline_compile_tc_byte ( parameter_string: string );
var tmp_pos: string;
    tmp_reg: string;
begin
  tmp_pos := load_stack_position ( parameter_string );
  tmp_reg := get_freeregister;
  if find_size ( parameter_string ) > 1 then
   tmp_pos := conv_to_str ( 4 - find_size ( parameter_string )) + '+' + tmp_pos;
  output ( '  move.b '+tmp_pos+','+tmp_reg+#13#10+
           '  ext.l '+tmp_reg );
  public_stack_position := tmp_reg;
end;

begin
 new ( inline_class_object, init );

 new ( inc_inline_class, init ( 'inc', inline_compile_inc, return_code ));
 inline_class_object^.add_inline_func ( inc_inline_class );

 new ( dec_inline_class, init ( 'dec', inline_compile_dec, return_code ));
 inline_class_object^.add_inline_func ( dec_inline_class );

 new ( sizeof_inline_class, init ( 'sizeof', inline_compile_sizeof, return_number ));
 inline_class_object^.add_inline_func ( sizeof_inline_class );

 new ( inline_compile_typecast_word, init ( 'word', inline_compile_tc_word, return_reg ));
 inline_class_object^.add_inline_func ( inline_compile_typecast_word );

 new ( inline_compile_typecast_byte, init ( 'byte', inline_compile_tc_byte, return_reg ));
 inline_class_object^.add_inline_func ( inline_compile_typecast_word );
end.