
{

 UltraPascal math calculation

 created by MXM-TriX            mxmtrix@xoommail.com
 released by MXM Projects       http://start.at/mxm


}

unit upas_mat;

interface

uses upas_def, upas_str, upas_fl, upas_sys;

var usingsize: string;

function calculate_array_pos ( s: string; ppvar: ppascal_var ): string;
function conversion_possible ( varname: string ): boolean;
function type_conversion ( typ_1, typ_2 : var_types ): boolean;
function get_parameter (var s: string): string;
function calculate ( x: string; compile: boolean): string;
function compile_calculation (calc_str: string; compile: boolean): string;
function test_nr ( x: string ): string;
function get_pascal_var_descriptor (name: string; search_from: ppascal_var): ppascal_var;
function pre_calculation ( str: string ): string;
function pre_compile_string ( x: string ): string;
function find_str_name ( s: string ): string;
function compile_string_calc ( x: string; compile: boolean ): string;
function getoperand ( x: string; from: integer; direction: integer ): string;
function load_stack_position ( name : string ): string;
procedure load_data ( source, destination: string; direction: boolean);
function do_calc ( op1, op2, operation: string; compile: boolean): string;
function get_size_nr ( short_cut: string ): word;
function get_size_str ( vtype : var_types ): string;
function format_string( str: string): string;
procedure compile_own_call ( s: string; need_a_result: boolean );
function find_size ( name: string ): word;
function find_var ( name: string ): ppascal_var;

implementation

uses upas_tk, upas_inl;

var use_float : boolean;
    func_lvl  : word; { -->> func_lvl > 0 then call MergeFuncLvl }

function get_parameter (var s: string): string;
var opened_rackets: string;
    output_str: string;
    string_read: boolean;
begin
opened_rackets := '';
output_str:='';
string_read:=false;
while (s <> '') do begin
  case s[1] of
   '[': opened_rackets := opened_rackets + ']';
   '(': opened_rackets := opened_rackets + ')';
   ')',']': if s[1]<>opened_rackets[1] then
              error(6)
            else
              delete(opened_rackets,1,1);
   '''': string_read:=not string_read;
   ',': if not string_read and (opened_rackets = '' )then break;
  end;
  output_str:=output_str+s[1];
  delete ( s, 1, 1);
end;
delete ( s, 1, 1);
get_parameter := output_str;
end;

{ -->> Calculate the position of the array in the memory >>-- }
function calculate_array_pos ( s: string; ppvar: ppascal_var ): string;
var buffer_string : string;
    pos_p         : word;
    calc_str      : string;
    su            : string;
begin
 calc_str := ppvar^.descriptor_string;
 if (pos ('[', s )=0)or(pos(']', s)=0)then error_txt ('Wrong arrayindex');
 s := trim(copy(s, str_pos('[', s)+1, str_pos(']', s)-str_pos('[', s)-1))+',';
 while str_pos('%v', calc_str)>0 do begin
   buffer_string := get_parameter(s);
   pos_p := str_pos('%v', calc_str);
   delete(calc_str, pos_p, 2);
   insert(buffer_string, calc_str, pos_p);
 end;
 if s <> '' then error(21);
 su := usingsize;
 usingsize := 'w';
 calc_str := calculate ( calc_str, true );
 usingsize := su;
 calculate_array_pos := calc_str;
end;

{
 CONVERSION_POSSIBLE tests, if the conversion from the variable var to the
 size of the variable destinationvar possible is
}

var destinationvar : string;
const
values : array[_byte .. _external] of word =
 (	c_byte_value,
        c_word_value,
        c_long_value,
        c_pointer_value,
        c_real_value,
        c_string_value,
        c_record_value,
        c_array_value,
        c_array_record_value,
        c_no_type_value,
        c_char_value,
        c_dword_value,
        c_shortint_value,
        c_whitespaces_value,
        c_sprites_value,
        c_external_value );

conversion_table: array[_byte .. _external] of word =
({_BYTE} c_byte_value or c_word_value or c_long_value or c_pointer_value or c_char_value or c_dword_value or c_shortint_value,
 {_WORD} c_dword_value or c_long_value or c_pointer_value or c_dword_value,
 {_LONG} c_long_value or c_pointer_value or c_dword_value,
 {_POINTER} c_long_value or c_pointer_value or c_dword_value,
 {_REAL} c_real_value,
 {_STRING} c_string_value,
 {_RECORD} c_record_value,
 {_ARRAY} c_array_value,
 {_ARRAY_RECORD} c_array_record_value,
 {_NO_TYPE} c_no_type_value,
 {_CHAR} c_char_value or c_byte_value or c_word_value or c_long_value or c_pointer_value or c_dword_value or c_shortint_value
         or c_string_value,
 {_DWORD} c_dword_value or c_long_value or c_pointer_value,
 {_SHORTINT} c_shortint_value or c_byte_value or c_word_value or c_pointer_value or c_char_value or c_dword_value,
 {_WHITESPACES} c_whitespaces_value,
 {_SPRITES} c_sprites_value,
 {_EXTERNAL} c_external_value );


function conversion_possible ( varname: string ): boolean;
var p1, p2: ppascal_var;
    v1, v2: var_types;
    pv1   : ppascal_procedure;
    s	  : string;
    fname : string;
begin

{ Check VARNAME }
 if (test_nr ( varname )='')and (not test_register ( varname )) then begin
  p1 := get_pascal_var_descriptor ( varname, local_first_variable );
  if p1 = nil then p1 := get_pascal_var_descriptor ( varname, global_first_variable );
  if p1 = nil then begin
   pv1 := first_procedure;
   if pos ('(', varname) > 0 then
    fname := trim(copy ( varname, 1, pos ('(', varname)-1))
   else
    fname := trim(varname);
   while (pv1<>nil) and (upper_str(fname)<>pv1^.name) do
    pv1 := pv1^.next_procedure;
   if not assigned(pv1) then error_txt ('Unknown statement');
   v1 := pv1^.fkt_result;
  end else
   v1 := p1^.variabelntyp;
 end else
  if test_nr ( varname ) <> '' then begin
   if pos('.', varname)>0 then s := '.' else s := test_nr ( varname );
   case s[1] of
             'b': v1 := _byte;
             'w': v1 := _word;
             'l': v1 := _longint;
             '.': v1 := _real;
   end;
  end else
   v1 := _longint;

 if (test_nr ( destinationvar )<>'') then error_txt ( 'Wrong datatypes %%' );
 if (test_register ( destinationvar )) then
  v2 := _longint
 else begin
  p2 := get_pascal_var_descriptor ( destinationvar, local_first_variable );
  if p2 = nil then p2 := get_pascal_var_descriptor ( destinationvar, global_first_variable );
  if p2 = nil then error_txt ('Unknown variable');
  v2 := p2^.variabelntyp;
 end;

 conversion_possible := (conversion_table [v1] and values[v2]<>0) or
                        (test_register (varname)) or
                        ( v1 = v2 );
end;

function type_conversion ( typ_1, typ_2 : var_types ): boolean;
begin
 type_conversion := (conversion_table[typ_1] and values[typ_2]<>0)or(typ_1=typ_2);
end;

procedure start_func_lvl ( var i: word );
begin
 i := func_lvl;
end;

procedure stop_func_lvl ( i: word );
begin
 if i<func_lvl then begin
  call_library ( 'paslib', 'MergeFuncLvl' );
  func_lvl := i;
 end;
end;

function calculate ( x: string; compile: boolean): string;
var opened_rackets  : string;
    new_calc_string : string;
    i               : word;
    _str_pos         : word;
    rack_counter    : word;
    op1, op2        : string;
    c		    : char;
    reg_1, reg_2    : string;
    lastpos	    : word;
    temp_v	    : ppascal_var;
    curr_lvl        : word;
begin
{ Here the compiler first calculate all rackets -> Better parsing later }
start_func_lvl ( curr_lvl );
x := pre_calculation ( x + ';');
if x[length(x)] = ';' then
 delete ( x, length ( x ), 1);
if usingsize = '' then usingsize := 'w';
for rack_counter := 1 to 2 do begin
 lastpos := 1;
while true do begin
 if (search_start(rackets[rack_counter], x, lastpos) = 0) then break;
 op1 := copy ( x, search_start ( rackets[rack_counter], x, lastpos )-2, 255);
 if op1[1] = '(' then
  c := #0
 else
  c := op1[1];
 lastpos := search_start ( rackets[rack_counter], x, lastpos ) + 1;
 if not (c in [' ','+','-','*','/',#0])and(rackets[rack_counter] = '(') then continue;
 { Reading of this valid racket }
  delete ( op1, 1, 2 );
  opened_rackets := rackets[rack_counter+2];
  new_calc_string := '';
  i:=1;
  while opened_rackets <> '' do begin
   if pos(rackets[rack_counter], x)+i>length(x) then error(6);
   case x[pos(rackets[rack_counter], x)+i]of
    '(','[': opened_rackets:=x[pos(rackets[rack_counter], x)+i]+opened_rackets;
    ')',']': if copy(opened_rackets,1,1) <> x[pos(rackets[rack_counter], x)+i]then error(6) else delete(opened_rackets,1,1);
   end;
   new_calc_string := new_calc_string + x[pos(rackets[rack_counter], x)+i];
   inc (i);
  end;
  delete (new_calc_string, length(new_calc_string), 1);
  i := pos(rackets[rack_counter], x);
  delete (x, i, length(new_calc_string)+2);
  reg_1 := calculate ( new_calc_string, compile );
  if rackets[rack_counter]='[' then reg_1 := '[' + reg_1 + ']';
  insert(reg_1, x, i);
end;
end;
{ -->> Check, if string operations >>-- }
i := 1;
while not (x[i] in [' ','+','<','>','=','*','/','-'])and(i<=length(x)) do inc ( i );
op1 := copy ( x, 1, i-1 );
temp_v := get_pascal_var_descriptor ( op1, local_first_variable );
if temp_v = nil then temp_v := get_pascal_var_descriptor ( op1, global_first_variable );
if (x[1]='''')or((temp_v<>nil)and(temp_v^.variabelntyp = _string)) then begin
 if ( str_pos ('<', x ) > 0 ) or ( str_pos ('>', x ) > 0 ) or
    ( str_pos ('=', x ) > 0 ) then begin
 compile_string_calc ( x, compile );
 op2 := get_freeregister;
 if op2 <> 'd0' then begin
  output ('  move.w d0,'+op2+#13#10+
          '  movem.l (a7)+,d0');
  calculate := op2;
 end else
  calculate := 'd0';
 exit;
 end;
end;
{ Beginning of the operationsscanning }
{ PARSE_CALCULATE () }
for i:=0 to high(pascal_operands) do
 while operand_pos(pascal_operands[i].name, x)>1 do begin
  { Getting of the arguments }
  op1 := getoperand (x, pos(pascal_operands[i].name, x) - 1, -1);
  op2 := getoperand (x, pos(pascal_operands[i].name, x) + length(pascal_operands[i].name), 1);
  if (test_nr(op1)='') or (test_nr(op2)='') then begin
  reg_1 := op1;
  reg_2 := op2;
  if not test_register(op1)and(test_nr(op1)='') then begin
    reg_1 := get_freeregister;
    load_data ( op1, reg_1, false);
  end;
  if test_nr ( op1 )<>'' then reg_1 := copy ( test_nr ( op1 ), 3, 255 );
  if not test_register(op2)and(test_nr(op2)='') then begin
    reg_2 := get_freeregister;
    load_data ( op2, reg_2, false);
  end;
  if test_nr ( op2 )<>'' then reg_2 := copy ( test_nr ( op2 ), 3, 255 );
  if reg_2[1] = '#' then
   swap_str ( reg_1, reg_2 );
  end else begin
   reg_1 := op1;
   reg_2 := op2;
  end;
  _str_pos := pos(pascal_operands[i].name, x) - length(op1);
  delete (x, _str_pos, length(op1) + length(op2) + length(pascal_operands[i].name));

  insert (do_calc (reg_1, reg_2, trim(pascal_operands[i].name), compile), x, _str_pos);
  set_registerstate ( reg_1, false );
 end;
set_registerstate ( reg_2, false );
stop_func_lvl ( curr_lvl );
calculate := x;
end;

function compile_calculation (calc_str: string; compile: boolean): string;
var savewhere                : string;
    ppvar                    : ppascal_var;
    temp_v		     : ppascal_var;
    res_in                   : string;
    size_to_save	     : string[2];
    prev_size		     : string;
    real_calc_str	     : string;
    fvl                      : word;
begin
if unit_compile and lib_def then begin
 output(calc_str);
 exit;
end;
start_func_lvl ( fvl );
ppvar := nil;
real_calc_str := calc_str;
calc_str := pre_calculation (calc_str);
if compile then begin
 prev_size := usingsize;
 savewhere := trim(copy(calc_str, 1, pos(':=', calc_str)-1));
 destinationvar := savewhere;
 if str_pos (':', savewhere) > 0 then begin
  size_to_save := savewhere[str_pos(':', savewhere)+1];
  delete ( savewhere, str_pos (':', savewhere), 255 );
  destinationvar := copy ( destinationvar, 1, length(destinationvar)-2);
 end else
  size_to_save := '';
 if not test_register(savewhere)and(size_to_save<>'s') then begin
  ppvar := get_pascal_var_descriptor ( savewhere, local_first_variable );
  if ppvar = nil then ppvar := get_pascal_var_descriptor ( savewhere, global_first_variable );
  if (ppvar = nil) then error (1);
  if (ppvar^.rechte) then error (12);
  if ppvar <> nil then begin
   use_float := (ppvar^.variabelntyp = _real);
   if ppvar^.variabelntyp <> _array then
    usingsize := get_size_str ( ppvar^.variabelntyp )
   else
    usingsize := get_size_str ( ppvar^.arraytyp );
  end else
   error_txt ( 'Unknown variable, where the result should be stored' );
 end else
  if size_to_save <> 's' then
   usingsize := 'w';
 if (size_to_save='s')or((ppvar <> nil) and (ppvar^.variabelntyp = _string)) then begin
  if size_to_save='s' then
   delete ( real_calc_str, str_pos (':s', real_calc_str ), 2 );
  compile_string_calc ( real_calc_str, compile );
 end else begin
  calc_str := copy(calc_str, pos(':=', calc_str)+2,255);
  delete(calc_str, length(calc_str), 1);
  calc_str := trim(calc_str);
  res_in := calculate ( calc_str, true );
  if size_to_save <> '' then
   usingsize := size_to_save;
  load_data (res_in, savewhere, true);
  set_registerstate ( res_in, false );
  usingsize := prev_size;
 end;
end else
 compile_calculation := calculate ( calc_str, false );
stop_func_lvl ( fvl );
end;

function power ( base, what: longint ): longint;
var l, i: longint;
begin
if base = 0 then
 power := 1
else begin
 l := base;
 for i := 1 to what do
  l := l * base;
 power := l;
end;
end;

function test_nr ( x: string ): string;
var i           : word;
    k           : word;
    result_str  : string;
    l           : real;
    n           : longint;
begin
if x[1] = '#' then delete ( x, 1, 1 );
for i:=0 to high ( pascal_numeric_systems ) do
 if x[1] = pascal_numeric_systems[i].identification then begin
  { controll chars }
  while x[2] = '0' do delete ( x, 2, 1 );
  for k:=2 to length(x) do
   if pos(x[k], pascal_numeric_systems[i].allowed_chars)=0 then error(11);
  if power ( pascal_numeric_systems[i].base, length(x)-1)>$FFFF then
   result_str := 'l'
  else
   result_str := 'w';
  test_nr := result_str + ' #'+x;
  exit
 end;
{ Test for decimal system }
while (x[1] = '0')and(length(x)>1) do delete ( x, 1, 1);
val (x, l, k);
if use_float and (k=0)then begin
 result_str := convert_float_to_hexstr ( l );
 if result_str[1] <> '$' then error_txt(' Error during float conversion: '+result_str);
 test_nr := 'l #'+result_str;
 exit;
end;
if k <> 0 then
 test_nr := ''
else begin
 n := round ( l );
 if abs(n) > 32767 then
  test_nr := 'l #'+conv_to_str ( n )
 else
  test_nr := 'w #'+conv_to_str ( n );
end;
end;

function find_pascal_procedure ( s: string ): ppascal_procedure;
var curr: ppascal_procedure;
    fname : string;
begin
fname := s;
if pos ( '(', s ) > 0 then
 fname := copy ( fname, 1, pos ( '(', fname ) - 1 );
fname := trim ( fname );
curr := first_procedure;
while ( curr <> nil ) and ( upper_str ( fname ) <>  upper_str ( curr^.name )) do
 curr := curr^.next_procedure;
find_pascal_procedure := curr;
end;



function get_pascal_var_descriptor (name: string; search_from: ppascal_var): ppascal_var;
var buffer_string: string;
    opened_rackets: string;
    str_index: word;
    current_pvar: ppascal_var;
    record_search: boolean;
    i: word;
begin
{
  Suchen, rekursiv von links nach rechts -> ermglicht auch 'records' in
  'records'
}
 { String schn sauber ausscannen }
 for i:=0 to high(prefix_or_suffix) do
  while str_pos(prefix_or_suffix[i].name, name)>0 do
   delete(name, str_pos(prefix_or_suffix[i].name, name), 1);

 opened_rackets := '';
 buffer_string := '';
 str_index := 1;
 while (str_index<=length(name))or(name[str_index]<>'.')and(opened_rackets<>'') do begin
  case name[str_index] of
   '[','(': if name[str_index] = '(' then
             opened_rackets:=opened_rackets+')'
            else
             opened_rackets := opened_rackets + ']';
   ')',']': if name[str_index]<>opened_rackets[1] then error(6) else delete(opened_rackets,1,1);
  end;
  if (opened_rackets = '')and not(name[str_index] in [']',')']) then buffer_string := buffer_string + name[str_index];
  inc(str_index);
 end;

 delete (name, 1, str_index);

 if length(name)>0 then begin
  record_search := (name[1]='.');
  if record_search then delete (name, 1, 1);
 end else record_search:=false;

 { Suchen der Variable }
 current_pvar := search_from;
 buffer_string := trim ( buffer_string );
 while (current_pvar <> nil)and(upper_str ( current_pvar^.name) <> upper_str (buffer_string)) do
  current_pvar:=current_pvar^.next_var;

 if (current_pvar = nil)or(upper_str(current_pvar^.name) <> upper_str(buffer_string)) then begin
  current_pvar:=nil;
  record_search:=false;
 end;

 if record_search then
  current_pvar := get_pascal_var_descriptor (name, current_pvar^.record_first_var);
 get_pascal_var_descriptor:=current_pvar;
end;

function pre_calculation ( str: string ): string;
var argument_str         : string;
    k                    : word;
    buffer_pvar          : ppascal_var;
    output_string        : string;
    save_in              : string;
begin
delete ( str, length(str), 1);
if str_pos(':=', str)>0 then begin
 save_in := copy(str, 1, str_pos(':=', str)+1);
 delete(str,1, length(save_in));
 str := trim(str);
end else
 save_in := '';
str := format_string ( str );
output_string := '';
while str <> '' do begin
 argument_str := '';
 while true do begin
  for k:=0 to high(pascal_operands) do
   if pascal_operands[k].name = copy(str, 1, length (pascal_operands[k].name)) then break;
  if (pascal_operands[k].name = copy(str, 1, length (pascal_operands[k].name))) or (str = '') then begin
  { Try to insert an untyped constant }
   buffer_pvar := get_pascal_var_descriptor (argument_str, global_first_variable);
   if buffer_pvar <> nil then begin
    if buffer_pvar^.rechte and (buffer_pvar^.variabelntyp=_no_type) then
     output_string := output_string + buffer_pvar^.const_string
    else
     output_string := output_string + argument_str;
   end else
    output_string := output_string + argument_str;
    if str <> '' then output_string := output_string + pascal_operands[k].name;
   break;
  end;
  argument_str := argument_str + str[1];
  delete (str, 1, 1);
 end;
 delete (str, 1, length(pascal_operands[k].name));
end;
pre_calculation := save_in+output_string+';';
end;

function do_calc ( op1, op2, operation: string; compile: boolean): string;
var l1, l2, lresult     : longint;
    lr1, lr2, lrresult  : real;
    buffer_string       : string;
    x                   : word;
    lbl_1, lbl_2	: string;
begin
operation := trim(operation);
op1 := trim(op1);
op2 := trim(op2);
if (test_nr(op1)<>'') and (test_nr(op2)<>'') then begin
 if copy(test_nr(op1), 1, 1)='r' then begin
  val(op1, lr1, x)
 end else val(op1, l1, x);
 if copy(test_nr(op2), 1, 1)='r' then begin
  val(op2, lr2, x);
  if not use_float then l2:=round(lr2);
 end else val(op2, l2, x);
 if operation = '+' then
    if use_float then lrresult := lr1 + lr2 else lresult := l1 + l2;
 if operation = '-' then
    if use_float then lrresult := lr1 - lr2 else lresult := l1 - l2;
 if operation = '*' then
    if use_float then lrresult := lr1 * lr2 else lresult := l1 * l2;
 if (operation = '/')or(operation='div') then
    if use_float then lrresult := lr1 / lr2 else lresult := l1 div l2;
 { All other operations will be added }
 if use_float then str (lrresult, buffer_string) else str(lresult, buffer_string);
 do_calc := buffer_string;
 exit;
end else begin
 if test_nr ( op1 ) <> '' then op1 := copy ( test_nr ( op1 ), 3, 255 );
 if test_nr ( op2 ) <> '' then op2 := copy ( test_nr ( op2 ), 3, 255 );
 do_calc := '';
 if not compile then exit;
 do_calc := op2;
 { Get operation }
 for x:=0 to high(pascal_operands) do
  if trim(pascal_operands[x].name) = operation then begin
   { Check register validity / only when floats are used}
   if (pascal_operands[x].reg_1 <> '') and (pascal_operands[x].reg_1 <> op2) and use_float then
     { Load into necessary register }
     output('  move.' + usingsize + ' ' + op2 + ',' + pascal_operands[x].reg_1);
   if (pascal_operands[x].reg_2 <> '') and (pascal_operands[x].reg_2 <> op1) and use_float then
     output('  move.' + usingsize + ' ' + op1 + ',' + pascal_operands[x].reg_2);
   if pascal_operands[x].branch_code_signed <> '' then begin
     if use_float then
      call_library ( 'ffp68343', 'ffpcmp' )
     else
      output ('  cmp.' + usingsize + ' ' + op1 + ',' + op2 );
     output ('  s' + copy ( pascal_operands[x].branch_code_signed, 2, 2 ) + ' ' + op2 );
     do_calc := op2;
   end else begin
   { Do operation }
   if use_float then begin
     call_library ( 'ffp68343', pascal_operands[x].float_equal );
     { Result is always in D7, all other functions aren't supported }
     output ('  move.l d7,'+op2);
   end else
     if trim (pascal_operands [ x ].name) <> 'mod' then
      output('  '+pascal_operands[x].non_float_equal+'.'+usingsize+' '+op1+','+op2)
     else begin
      if get_size_nr ( usingsize ) < 4 then
       output ('  ext.l '+op1+#13#10+
               '  ext.l '+op2);
      compile_calculation ( '-(a6):l:='+op1+';', true );
      compile_calculation ( '-(a6):l:='+op2+';', true );
      call_library ( 'paslib', 'pascal_mod' );
      output ( '  move.'+usingsize + ' __pascal_function_result+'+conv_to_str ( 4 - get_size_nr ( usingsize ))+','+op2);
     end;
  end;
  end;
end;
end;

function pre_compile_string ( x: string ): string;
var in_string: boolean;
    output_str : string;
    i          : word;
    current_var: string;
    ppvar      : ppascal_var;
    s,kl       : word;
    no_write   : boolean;
    save_s     : string;
begin
if str_pos (':=', x)>0 then begin
 save_s := copy ( x, 1, str_pos (':=', x)+1);
 delete ( x, 1, str_pos (':=', x)+1);
end else
 save_s := '';

 x := trim ( x );
in_string := false;
i := 1;
output_str := '';
current_var := '';
no_write := false;
while i <= length(x) do begin
 case x[i] of
  '''': begin
         if x[i+1]='''' then begin
          output_str := output_str + '''';
          in_string := true;
         end;
         if x[i-1]<>'''' then begin
          if in_string then output_str := output_str + '''';
          in_string := not in_string;
         end;
        end;
  ' ':  begin
         if not in_string then begin
	    inc ( i );
	    continue;
	 end;
        end;
  ';':  begin
         output_str := output_str + ';';
         inc ( i );
         continue;
        end;
 end;
 if not in_string then begin
  if x[i] <> '''' then
   current_var := current_var + x[i]
 end else
  if not no_write then output_str := output_str + x[i];
 no_write := false;
 if not in_string and (x[i] = '+')and( current_var <> '+' ) then begin
  if pos('+', current_var) = 0 then error(10);
  delete(current_var, 1, pos('+', current_var));
  current_var := trim(current_var);
  if pos('+', current_var) = 0 then error(10);
  delete(current_var, pos('+', current_var), 1);
  current_var := trim(current_var);
  { Searching in CONST table for the definition }
  if current_var[1] = '#' then begin
     val(copy(current_var, 2, 255), s, kl);
     output_str := copy(output_str, 1, length(output_str) - 1) + char(s);
     no_write := true;
  end else begin
   ppvar := get_pascal_var_descriptor ( current_var, local_first_variable );
   if ppvar = nil then ppvar := get_pascal_var_descriptor ( current_var, global_first_variable );
   if (ppvar = nil)or(ppvar^.variabelntyp <> _no_type) then
    output_str := output_str+'+'+current_var+'+'
   else begin
    delete(output_str, length(output_str), 1);
    output_str := output_str + ppvar^.const_string;
    no_write := true;
   end;
  end;
  current_var := '';
 end;
 inc(i);
end;
pre_compile_string := save_s + output_str;
end;

function find_str_name ( s: string ): string;
var temp_v : ppascal_var;
    temp_p : ppascal_procedure;
    str_content: string;
    i: word;
begin
if s[1] <> '''' then begin
 temp_v := get_pascal_var_descriptor ( s, local_first_variable );
 if temp_v = nil then
  temp_v := get_pascal_var_descriptor ( s, global_first_variable );
 if (temp_v = nil)or(temp_v^.variabelntyp <> _string) then begin
  { -->> Find function >>-- }
  temp_p := find_pascal_procedure ( s );
  if ( temp_p = nil )or( temp_p^.fkt_var = nil ) or ( temp_p^.fkt_var^.variabelntyp <> _string ) then
   error_txt ( 'No string' );
  compile_own_call ( s, true );
  s := '__pascal_function_result';
 end;
 find_str_name := s;
 exit;
end;
delete ( s, 1, 1 );
if s[length(s)] = '''' then
 delete ( s, length(s), 1 );
{ -->> Search string >>-- }
for i := 0 to 1 do begin
if i = 0 then
 temp_v := local_first_variable
else
 temp_v := global_first_variable;
while temp_v<>nil do begin
 while (temp_v<>nil) and ( temp_v^.variabelntyp <> _string ) do
  temp_v := temp_v^.next_var;
 if (temp_v <> nil ) then begin
  str_content := copy ( temp_v^.const_string, 7, 255 );
  str_content := copy ( str_content, 1, pos ('",0', str_content )-1);
  if str_content = s then begin
   find_str_name := temp_v^.name;
   exit;
  end;
  temp_v := temp_v^.next_var;
 end;
end;
end;
{ -->> Create new string >>-- }

if unit_compile then
 str_content := unit_name
else
 str_content := '';
build_var_type ( str_content + '_apv_' + conv_to_str ( apv_counter ) + ' : string = ''' + s + ''';',
                 global_last_variable, global_first_variable, false, true, false );
find_str_name := str_content + '_apv_'+conv_to_str ( apv_counter );
inc ( apv_counter, 1 );
end;

function read_str_par ( var s: string ): string;
var in_string: boolean;
    last_c   : char;
    curr_c   : char;
    output_str: string;
begin
 output_str := '';
 in_string := false;
 last_c := #0;
 repeat
  curr_c := s[length(s)];
  delete ( s, length(s), 1 );
  case curr_c of
    '''': if last_c = '''' then begin
           output_str := output_str + '''';
           continue;
          end else
           in_string := not in_string;
    '+':  if not in_string then break;
  end;
  output_str := curr_c + output_str;
  last_c := curr_c;
 until(length(s)=0);
 read_str_par := trim(output_Str);
end;

{ -->> Real handling >>-- }

function compile_string_calc ( x: string; compile: boolean ): string;
var save_str		: string;
    right_side		: string;
    size		: string;
    curr_s		: string;
    v_name		: string;
    stack_p		: string;
    var_1		: ppascal_var;
    reg_1		: string;
    curr_lbl		: string;
    compare_set		: boolean;
    compare_str_addr    : array[0..1] of string;
    str_calc_temp_counter : word;
    i			: word;
    branch_code		: string[4];

procedure load_one_side;
begin
  output_commentbox ( 'Stringoperations' );
  if compare_set then
   output ('  move.l #$fffffffe,-(a6)')
  else
   output ( '  move.l #$ffffffff,-(a6)');
  while right_side <> '' do begin
   curr_s := read_str_par ( right_side );
   right_side := trim ( right_side );
   v_name := find_str_name ( curr_s );
   if v_name <> '__pascal_function_result' then
    stack_p := load_stack_position ( v_name )
   else
    stack_p := v_name;
   if stack_p[1] <> '(' then begin
    output ('  lea '+stack_p+',a0');
    output ('  move.l a0,-(a6)');
   end else
    output ('  move.l '+stack_p+',-(a6)');
  end;
  output ('  move.w #'+size+'+'+conv_to_str(str_calc_temp_counter)+'*$100,-(a6)');
  if (stack_p[1] <> '-')and not compare_set then begin
   stack_p := load_stack_position ( save_str );
   output ('  lea '+stack_p+',a0');
   output ('  move.l a0,-(a6)');
  end else
   if compare_set then begin
    output ( '  lea -4(a6),a6');
    compare_str_addr [ str_calc_temp_counter ] := '#$ffffffff-'+conv_to_str(str_calc_temp_counter);
   end else
    output ('  move.l #$fffffffe,-(a6)');
  { -->> Call PASLIB >>-- }
  new ( temp_container, init );
  temp_container^.add_string ( 'paslib' );
  temp_container^.add_string ( 'strcat' );
  fargo_version_stream^.insert ( _librarycall, form_container_2, temp_container, curr_s );
  dispose ( temp_container, done );
  output (curr_s);
end;

begin
{ x := pre_compile_string ( x );}
 size := '';
 str_calc_temp_counter := 0;



 if pos ( ':=', x ) > 0 then begin
  save_str := trim (copy ( x, 1, str_pos (':=', x)-1));
  curr_lbl := copy ( x, str_pos (':=', x ) +2 ,255 );
 end else begin
  save_str := '';
  curr_lbl := x;
 end;
 compare_set := ( str_pos ( '<', curr_lbl ) > 0 ) or ( str_pos ( '>', curr_lbl ) > 0 ) or
                ( str_pos ( '=', curr_lbl ) > 0 );

 { -->> No check, because this procedure is only called, when it is a
        stringmanipulation >>-- }
 if pos (':', save_str ) > 0 then begin
  size := copy ( save_str, pos (':', save_str ) + 1, 255 );
  delete ( save_str, pos (':', save_str ), 255);
 end;

 for str_calc_temp_counter := 0 to byte ( compare_set ) do begin


 if save_str <> '' then
  right_side := trim (copy ( x, str_pos (':=', x )+2, 255 ))
 else begin
  right_side := x;
  i := 1;
  while not (x [ i ] in ['>','<','='])do inc ( i );
  if str_calc_temp_counter = 0 then
   right_side := copy ( x, 1, i-1 )
  else begin
   branch_code := x[i];
   if x[i+1] in ['>','<','='] then begin
    inc ( i );
    branch_code := branch_code + x[i];
   end;
   right_side := copy ( x, i+1, 255 );
  end;
 end;
 if right_side [ length ( right_side ) ] = ';' then
  dec ( byte(right_side[0]));
 if not compare_set and not test_register ( save_str ) then begin
  if right_side [ length ( right_side ) ] = ';' then
   delete ( right_side, length(right_side), 1);
  var_1 := get_pascal_var_descriptor ( save_str, local_first_variable );
  if var_1 = nil then
   var_1 := get_pascal_var_descriptor ( save_str, global_first_variable );
  if var_1 = nil then error_txt ( 'Unknown stringvariable' );
  if var_1^.variabelntyp <> _string then
   error_txt ( 'Wrong datatype' );
  if size='' then size := conv_to_str ( var_1^.size );
 end;
 if str_pos ( '+', right_side )=0 then begin
  right_side := find_str_name ( right_side );
  if not compare_set then begin
   output_commentbox ( 'Stringcopy' );
   if save_str[1] <> '-' then begin
    stack_p := load_stack_position ( save_str );
    if stack_p[1] <> '(' then
     output ('  lea '+stack_p+',a0');
   end else begin
    if save_str = '-(a6)' then
     output ('  lea -'+conv_to_str ( standard_string_size )+'(a6),a6'+#13#10+'  move.l a6,a0')
    else begin
     output ('  pea '+load_stack_position ( right_side ));
     exit;
    end;
    size := conv_to_str ( standard_string_size );
   end;
   if right_side <> '__pascal_function_result' then
    stack_p := load_stack_position ( right_side )
   else
    stack_p := right_side;
   if stack_p[1] <> '(' then
    output ('  lea '+stack_p+',a1')
   else
    output ('  move.l '+stack_p+',a1');
   reg_1 := get_freeregister;
   output ('  moveq #'+size+'-1,'+reg_1);
   new_label ( 'string_move', normal_label );
   curr_lbl := get_label ( normal_label );
   output (curr_lbl+':');
   output ('  move.b (a1)+,(a0)+');
   output ('  dbra '+reg_1+','+curr_lbl);
   set_registerstate ( reg_1, false );
  end else
   compare_str_addr [ str_calc_temp_counter ] := load_stack_position ( find_str_name ( right_side ));
  end else begin
    load_one_side;
 end;
 end;
 if compare_set then begin
  output ('; Calling of the compareroutine'+#13#10);
  reg_1 := get_freeregister;
  if reg_1 <> 'd0' then
   output ('  movem.l d0,-(a7)');
  set_registerstate ( reg_1, false );
  output ('  move.l '+compare_str_addr[0]+',-(a6)'+#13#10+
          '  move.l '+compare_str_addr[1]+',-(a6)');
  new ( temp_container, init );
  temp_container^.add_string ( 'paslib' );
  temp_container^.add_string ( 'strcmp' );
  fargo_version_stream^.insert ( _librarycall, form_container_2, temp_container, curr_s );
  dispose ( temp_container, done );
  output (curr_s);
  { -->> Search branchcode >>-- }
  for i := 0 to high ( pascal_operands ) do
   if pascal_operands[i].name = branch_code then begin
    output ('; Comparing'+#13#10+
            '  tst.w d0'+#13#10+
            '  s'+copy ( pascal_operands[i].branch_code_signed, 2, 2 )+' d0');
    exit;
   end;
 end;
end;

function getoperand ( x: string; from: integer; direction: integer ): string;
var output_string   : string;
    rk              : word;
    instr           : boolean;
    infloat         : boolean;
    nx_1            : string;
    px_1            : string;
    term_1,term_2   : set of char;
begin
output_string := '';
rk := 0;
instr := false;
if direction = -1 then begin
 term_1 := ['0'..'9'];
 term_2 := ['e'];
end else begin
 term_2 := ['0'..'9'];
 term_1 := ['e'];
end;
if x[from] in ['0'..'9'] then infloat := true else infloat := false;
while true do begin
 if (from=0)or(from>length(x)) then break;
 nx_1 := #0#0;
 px_1 := #0#0;
 nx_1 := copy ( x, from+direction, 1 );
 px_1 := copy ( x, from-direction, 1 );
 case x[from] of
   '''': instr := not instr;
   '(','[': if not instr then inc ( rk );
   ')',']': if not instr then dec ( rk );
   ' ','*','/','=','>','<': if rk = 0 then break;
   '+': if (nx_1[1] in term_1)and(px_1[1] in term_2)and infloat then
        else
         break;
   '-': begin
         if (nx_1[1] in term_1)and(px_1[1] in term_2)and infloat then
         else
          if (from=1) or (length(output_string)=0) or (x[from+direction] in [' ','*','/','+']) then
          else
          if rk = 0 then break;
        end;
 end;
 if direction = -1 then
  output_string := x[from] + output_string
 else
  output_string := output_string + x[from];
 inc (from, direction);
end;
getoperand := output_string;
end;

function load_stack_position ( name : string ): string;
var    add_size              : string;
       optimized_load        : word;
       var_name              : string;
       ppvar, first_var,
       ppvar_2               : ppascal_var;
       global                : boolean;
       which_reg             : string[10];
       rel_addr              : integer;
       first                 : boolean;
       buffer_str            : string;
       use_reg               : string;
       x                     : word;
       l                     : longint;
       offset_str            : string;
       vname		     : string;
       res_str		     : string;
       tmp_r                 : string;
begin
 if test_register ( name )or(test_nr ( name ) <> '') then begin
   if test_nr ( name ) <> '' then
    load_stack_position := copy ( test_nr ( name ), 3, 255 )
   else
    load_stack_position := name;
   exit;
 end;
 name := pre_calculation ( name + ';');
 delete ( name, length(name), 1);
 if test_nr ( name ) <> '' then begin
   load_stack_position := copy(test_nr (name), 3, 255);
   exit;
 end;
 if str_pos ( '(', name ) > 0 then begin
  vname := trim ( copy ( name, 1, str_pos ('(', name)-1));
  buffer_str := trim ( copy ( name, str_pos ('(', name)+1, 255 ));
  while buffer_str[length(buffer_str)] <> ')' do
   dec ( byte ( buffer_str[0] ));
  dec ( byte ( buffer_str[0] ));
  if inline_class_object^.check_inline_func ( vname, buffer_str, return_number ) and
      (public_inline_number_result <> $FFFF) then
   load_stack_position := '#' + conv_to_str ( public_inline_number_result )
  else begin
   compile_own_call ( name, true );
   load_stack_position := '__pascal_function_result';
  end;
  exit;
 end;
 if str_pos ( '::', name )>0 then begin
   { Libraryvariable -->> Only in globals }
   ppvar := global_first_variable;
   while ( ppvar <> nil ) and ( upper_str ( name ) <> upper_str ( ppvar^.name )) do
    ppvar := ppvar^.next_var;
   if ppvar <> nil then begin
    if ppvar^.prev_c <> #0 then
     load_stack_position := ppvar^.prev_c + ppvar^.name
    else
     load_stack_position := ppvar^.name;
   end else
    error_txt ( 'No libraryvariable' );
   exit;
 end;
 { Load the stack position of the variable }
 if str_pos('.', name)>0 then
  var_name := trim(copy(name, 1, str_pos('.', name)-1))
else
 var_name := trim(name);
which_reg := 'a5';
global := false;
ppvar := get_pascal_var_descriptor ( var_name, local_first_variable );
if ppvar = nil then begin
 ppvar := get_pascal_var_descriptor ( var_name, global_first_variable );
 which_reg := 'a4';
 global := true;
end;
if (ppvar = nil)and (test_nr(var_name)='') then error(1);
first := true;
first_var := ppvar;
if global then begin
 { Write a string, so no relocation in units is necessary }
 buffer_str := '0';
 vname := first_var^.name;
end else begin
 buffer_str := conv_to_str(first_var^.stackpos);
 if first_var^.var_set then begin
  which_reg := get_free_a_register;
  output ( '  move.l ' + conv_to_str(first_var^.stackpos) + '(a5),'+which_reg );
 end;
end;
use_reg := get_freeregister;
rel_addr := -1;
while name <> '' do begin
if first then begin
 val ( buffer_str, l, x);
 rel_addr := l;
 first := false;
end;
delete (name, 1, length(var_name));
if test_nr(var_name)<>'' then continue;
if ppvar^.variabelntyp = _array then begin
 { Calculate position, by inserting of the code}
 buffer_str := calculate_array_pos (var_name, ppvar);
 delete ( var_name, pos ('[', var_name ), 255 );
 var_name := trim ( var_name );
 if test_nr(buffer_str)<>'' then begin
{  buffer_str := '#'+buffer_str;}
  val ( buffer_str, l, x);
  rel_addr := rel_addr + l;
 end else begin
  if rel_addr = -1 then begin
   output('  add.w '+buffer_str+','+use_reg)
  end else begin
   tmp_r := buffer_str;
   str ( rel_addr, buffer_str );
   output('  move.w #'+buffer_str+'+'+first_var^.name+'-_comment,'+use_reg);
   if use_reg <> tmp_r then output ('  add.w '+tmp_r+','+use_reg);
   rel_addr := -1;
  end;
 end;
end;
if ppvar^.record_first_var <> nil then begin
 if name[1] <> '.' then error(23);
 var_name := copy( name , 2, 255);
 if pos('.', var_name)>0 then var_name := copy( var_name, 1, pos('.', var_name)-1);
 delete (name, 1, length(var_name)+1);
 var_name := trim(var_name);
 ppvar_2 := get_pascal_var_descriptor ( var_name, ppvar^.record_first_var );
 if ppvar_2 = nil then error(23);
 output('  add.w #'+conv_to_str(ppvar_2^.stackpos)+','+use_reg);
end;
end;
set_registerstate ( use_reg, false );

if rel_addr <> -1 then begin
 str ( rel_addr, offset_str );
 first := true;
end else
 first := false;

if not first then begin
  res_str := '0('+which_reg+','+use_reg+'.w)';
end else begin
 if global then
  res_str := offset_str + '+' + vname + '-_comment('+which_reg+')'
 else
  res_str := offset_str + '('+which_reg+')';
end;
load_stack_position := res_str;
if first_var^.var_set then
 set_registerstate ( which_reg, false );
end;

function find_var ( name: string ): ppascal_var;
var temp: ppascal_var;
begin
 temp := get_pascal_var_descriptor ( name, local_first_variable );
 if temp = nil then
  temp := get_pascal_var_descriptor ( name, global_first_variable );
 find_var := temp;
end;

function find_size ( name: string ): word;
var tp_v : ppascal_var;
begin
 tp_v := find_var ( name );
 if (test_nr ( name ) <> '') then begin
  find_size := get_size_nr ( copy ( test_nr ( name ), 1, 1 ));
  exit;
 end else begin
  find_size := get_size_nr ( usingsize );
  exit;
 end;
 if name[length(name)] = ']' then begin
  if not (tp_v^.variabelntyp in [_array,_string]) then
   error_txt ( 'Wrong arrayindex' );
  if tp_v^.variabelntyp = _string then
   find_size := 1
  else
   find_size := get_size_nr ( get_size_str ( tp_v^.arraytyp ));
  exit;
 end;
 find_size := tp_v^.size;
end;

procedure load_data ( source, destination: string; direction: boolean);
var       bool_array : array[0..2]of boolean;
          i          : word;
          op_1, op_2 : string;
          v          : ppascal_var;
          s1, s2     : word;
          tmp_r1,tmp_r2:      string;
          v1         : var_types;
          pv1, pv2   : ppascal_var;
          tmp_dst    : string;
          rd1        : string;
          copy_lbl   : string;
          sz_1       : word;
begin
{ Filtering of all possible prefixes }
if direction then swap_str ( source, destination );
for i := 0 to high(prefix_or_suffix) do bool_array[i] := false;
for i := 0 to high(prefix_or_suffix) do begin
 case prefix_or_suffix[i].op_pos of
        1: if (source [1] = prefix_or_suffix[i].name)and not test_register(source) then begin
            delete ( source, 1, 1);
            bool_array[prefix_or_suffix[i].tomodify] := true;
           end;
       -1: if source [length(source)] = prefix_or_suffix[i].name then begin
            delete ( source, length(source), 1);
            bool_array[prefix_or_suffix[i].tomodify] := true;
           end;

 end;
end;
if direction then swap_str ( source, destination );
if destinationvar = '' then
 destinationvar := destination;

if not direction then begin
 if not conversion_possible ( source ) then
  error_txt ('Wrong datatypes');
end;
{ Load the variable, number, ... into op_1 }
op_1 := load_stack_position ( source );
op_2 := load_stack_position ( destination );
if op_1[1] = '(' then
 set_registerstate ( copy ( op_1, 2, 2 ), false );
if op_2[1] = '(' then
 set_registerstate ( copy ( op_2, 2, 2 ), false );
if bool_array[0]then begin
 output('  lea '+op_1+','+op_2);
 exit;
end;
if bool_array[1]then begin
 output('  move.'+usingsize+' '+op_1+','+op_2);
 output('  neg.'+usingsize+' '+op_2);
 exit;
end;
if bool_array[2] then begin
 if direction then begin
  output('  lea '+op_2+',a3');
  output('  move.'+usingsize+' '+op_1+',(a3)')
 end else begin
  output('  lea '+op_1+',a3');
  output('  move.'+usingsize+' (a3),'+op_2);
 end;
 exit;
end;
if (op_1 <> '__pascal_function_result')and(op_2 <> '__pascal_function_result') then begin
if not test_register ( source ) and ( test_nr ( source ) = '') then begin
 v := get_pascal_var_descriptor ( source, local_first_variable );
 if v = nil then
  v := get_pascal_var_descriptor ( source, global_first_variable );
 if v^.variabelntyp = _array then
  v1 := v^.arraytyp
 else
  v1 := v^.variabelntyp;
  s1 := get_size_nr ( get_size_str ( v1 ));
end else
 s1 := 4;
if not test_register ( destination ) and ( test_nr ( destination ) = '') then
 begin
 v := get_pascal_var_descriptor ( destination, local_first_variable );
 if v = nil then
  v := get_pascal_var_descriptor ( destination, global_first_variable );
 if v^.variabelntyp = _array then
  s2 := get_size_nr ( get_size_str ( v^.arraytyp ))
 else
  s2 := get_size_nr ( get_size_str ( v^.variabelntyp ));
end else
 s2 := $FFFF;

if (s1<s2)and(s2<>$FFFF) then begin
{ -->> Adjust size >>--}
 tmp_r1 := get_freeregister;
 tmp_r2 := get_freeregister;
 output ('  move.'+get_size_str ( v1 ) + ' '+op_1+','+tmp_r2+#13#10+
         '  ext.'+usingsize + ' '+tmp_r2+#13#10+
         '  move.'+usingsize + ' '+tmp_r2+','+op_2);
 set_registerstate ( tmp_r2, false );
 set_registerstate ( tmp_r1, false );
 exit;
end;
end;
 { -->> Check, if it is bigger than 4 bytes >>-- }
 pv1 := find_var ( source );
 pv2 := find_var ( destination );
 { -->> Find size >>-- }
 sz_1 := find_size ( source );

 if test_register(source)or(test_nr(source)<>'')or(sz_1 <= 4) then begin
  output('  move.'+usingsize+' '+op_1+','+op_2);
 end else begin
  new_label ( 'copy_var', normal_label );
  copy_lbl := get_label ( normal_label );
  rd1 := get_freeregister;
  output ( '  lea '+op_1+',a1');
  if destination[1] = '-' then
   output ( '  lea -'+conv_to_str ( sz_1 ) + copy ( destination, 2, 255)+','+copy ( destination, 2, 255 )+#13#10+
            '  move.l '+copy ( destination, 2, 255 ) + ',a2')
  else
   output ( '  lea '+op_2+',a2' );
  output ( '  move.w #'+conv_to_str(sz_1)+'-1,'+rd1+#13#10+
           copy_lbl+':'#13#10+
           '  move.b (a1)+,(a2)+'#13#10+
           '  dbra.w '+rd1+','+copy_lbl);
 end;
end;

function get_size_nr ( short_cut: string ): word;
var i : word;
begin
 i := 0;
 while variable_data_types[i].savestr <> trim(short_cut) do inc(i);
 get_size_nr := variable_data_types[i].size;
end;

function get_size_str ( vtype : var_types ): string;
var i: word;
begin
if vtype = _string then begin
 get_size_str := 's';
 exit;
end;
for i := 0 to high(variable_data_types) do
 if variable_data_types[i].v_type = vtype then begin
  get_size_str := variable_data_types[i].savestr;
  exit;
 end;
end;
{
 ****************************************************************************
  format_string         -> formatting of the calculationstring, easier
  parsing is then possible.
  From Fargo Pascal
 ****************************************************************************
}
function format_string( str: string): string;
var output_string       : string;
    operand             : string;
    j                   : word;
    k                   : word;
    stopper             : boolean;
    instring		 : boolean;
begin
output_string := '';
instring := false;
while str <> '' do begin
 str := trim(str);
 operand := '';
 j := 1;
 while 1=1 do begin
  stopper:=false;
  for k:=0 to high(pascal_operands) do
   if pascal_operands[k].name = copy(str, 1, length(pascal_operands[k].name)) then begin
    stopper:=true;
    break;
   end;
  if stopper then break;
  if str[1] = '''' then instring := not instring;
  { Take out all ' ' }
  if (str[1] <> ' ') then
   output_string := output_string + str[1]
  else
   if instring then output_string := output_string + ' ';
  delete (str, 1, 1);
  if str = '' then break;
 end;
 if str <> '' then
  output_string := output_string + pascal_operands[k].name;
 str := copy(str, length(pascal_operands[k].name) + 1, 255);
end;
format_string := output_string;
end;

function count_char ( c: char; s: string): word;
var i, z: word;
begin
z := 0;
for i := 1 to length ( s ) do
 if s[i] = c then inc ( z );
count_char := z;
end;


function push_parameters (parameter_string: string; which: ppascal_var; given_size: boolean): word;
var act_parameter : string;
    concat_str	  : string;
    temp_v	  : ppascal_var;
    first_v	  : ppascal_var;
    call_levels	  : boolean;
    current_level : word;
    s		  : string;
    highest_level : word;
    temp_s	  : string;
    stack_correct : word;
    needed_reg    : string;

function get_call_parameter ( var s: string; w: word ): string;
var z,i : word;
    par_str: string;
    v: ppascal_var;
    old_par_str: string;
    tmp_s	: string;
    b1		: boolean;
begin
{ -->> Find parameterposition >>-- }
z := 1;
v := which;
while current_level<>which^.call_level do begin
 inc ( z );
 which := which^.next_var;
end;
needed_reg := which^.needed_register;
old_par_str := ''; i := 1;
while i<>z do begin
 old_par_str := old_par_str + get_parameter ( s )+',';
 inc ( i );
end;
par_str := copy ( s, 1, 255 );
if which^.name = '...' then begin
 used_white_spaces := true;
 b1 := false;
 while par_str <> '' do begin
   tmp_s := get_parameter ( par_str );
   if par_str <> '' then begin
    old_par_str := old_par_str + tmp_s + ',';
    b1 := true;
   end;
 end;
 if b1 then
  dec ( current_level );
 s := old_par_str;
 s := trim ( s );
 par_str := trim(tmp_s);
 { Set necessary informations }
 get_call_parameter := par_str;
 if par_str[1] = '''' then begin
  par_str := find_str_name ( par_str );
  get_call_parameter := par_str;
  which^.variabelntyp := _string;
  which^.var_set := true;
  exit;
 end;
 if par_str[1] = '''' then begin
  par_str := find_str_name ( par_str );
  get_call_parameter := par_str;
  which^.var_set := true;
  exit;
 end;
 v := get_pascal_var_descriptor ( par_str, local_first_variable );
 if v = nil then
  v := get_pascal_var_descriptor ( par_str, global_first_variable );
 if (v=nil)and(str_pos ('(', par_str)>0) then begin
  { -->> Find function >>-- }
 end;
 if v<>nil then begin
  get_call_parameter := par_str;
  if v^.variabelntyp = _string then begin
   which^.variabelntyp := _string;
   which^.var_set := true;
   exit;
  end;
  if (v^.variabelntyp in [_record]) then begin
   which^.var_set := true;
   which^.variabelntyp := _byte;
   exit;
  end;
  if v^.variabelntyp = _array then
   which^.variabelntyp := v^.arraytyp
  else
   which^.variabelntyp := v^.variabelntyp;
  which^.var_set := false;
  exit;
 end;
 if (test_nr ( par_str ) = '')and not test_register ( par_str ) then
  error_txt ( 'Error in whitespaces' )
 else
  which^.var_set := false;
end else begin
 s := old_par_str + par_str;
 while s[length(s)] = ',' do dec ( byte ( s[0] ));
 s := s + ',';
 par_str := trim(get_parameter ( s ));
 get_call_parameter := par_str;
 which := get_pascal_var_descriptor (par_str, local_first_variable);
 if (which = nil) then
  which := get_pascal_var_descriptor (par_str, global_first_variable);
 if (which <> nil)and(which^.variabelntyp = _no_type) then begin
   s := old_par_str + which^.const_String + ',';
   which := v;
   par_str := get_call_parameter (s, w);
 end;
 if (which <> nil) then
   which^.needed_register := needed_reg;

end;
if par_str[length(par_str)] = ',' then
 delete ( par_Str, length(par_str), 1);
if par_str [ 1 ] = '''' then
 par_str := find_str_name ( par_str );
get_call_parameter := par_str;
end;

begin
 if (parameter_string = '') then begin
  push_parameters := 0;
  exit;
 end;
 used_white_spaces := false;
 first_v := which;
 call_levels := first_v^.call_level > 0;
 current_level := byte ( call_levels );
 if call_levels then begin
  highest_level := 1;
  while which<>nil do begin
   inc ( highest_level );
   which := which^.next_var;
  end;
  dec ( highest_level );
  which := first_v;
 end;
 parameter_string := parameter_string + ',';
 stack_correct := 0;
 while parameter_string <> '' do begin
  if call_levels then begin
   which := first_v;
   act_parameter := trim(get_call_parameter ( parameter_string, current_level ));   inc ( current_level );
  end else begin
   act_parameter := get_parameter ( parameter_string );
   needed_reg := which^.needed_register;
  end;
   if given_size and not which^.var_set then
    if (test_nr ( act_parameter ) = '') then
     if (copy (act_parameter, 1, 5) = '_apv_') then
      concat_str := ':s'
     else begin
      if which^.variabelntyp = _array then
       concat_str := ':' + get_size_str ( which^.arraytyp )
      else
       concat_str := ':' + get_size_str ( which^.variabelntyp )
     end
    else
     concat_str := '';
   if which^.var_set then begin
    temp_v := get_pascal_var_descriptor ( act_parameter, local_first_variable );
    if (temp_v = nil ) and procedure_defined then
     temp_v := get_pascal_var_descriptor ( act_parameter, current_procedure^.first_var );
    if temp_v = nil then temp_v := get_pascal_var_descriptor ( act_parameter, global_first_variable );
    if (temp_v <> nil)and(which^.variabelntyp=_string)then begin
     if act_parameter[1] = '''' then begin
      act_parameter := find_str_name ( act_parameter );
      temp_v := get_pascal_var_descriptor ( act_parameter, global_first_variable );
     end;
    end;
    if (temp_v = nil)or not type_conversion ( temp_v^.variabelntyp, which^.variabelntyp ) then
     error_txt ( 'Variable with right type necessary! ( var )');
    s := load_stack_position ( act_parameter );
    if s[1] = '(' then
     output ('  move.l '+s+','+which^.needed_register)
    else
     if which^.needed_register<>'-(a7)' then
      output ( '  lea '+s+',a0'+#13#10+
               '  move.l a0,'+which^.needed_register)
     else
      output ('  pea '+s);
  end else
   compile_calculation (needed_reg + concat_str + ':=' + act_parameter + ';', true );
  if needed_reg = '-(a7)' then begin
   which := get_pascal_var_descriptor (act_parameter, local_first_variable);
   if (which = nil) then    which := get_pascal_var_descriptor (act_parameter, global_first_variable);
   if not which^.var_set then
    if test_nr ( act_parameter ) <> '' then
     inc ( stack_correct, get_size_nr ( copy ( test_nr ( act_parameter ), 1, 1 )))
    else
     if which^.variabelntyp = _string then
      inc (stack_correct, 4)
     else
      if which^.variabelntyp = _array then
       inc ( stack_correct, get_size_nr ( get_size_str (which^.arraytyp )))
      else
       inc ( stack_correct, get_size_nr ( get_size_str (which^.variabelntyp )))
   else
    inc ( stack_correct, 4 );
   end;
   if(which^.next_var = nil)and(parameter_string <> '')and not used_white_spaces then
    if not call_levels then
     error_txt ( 'Too many arguments' )
    else
     if call_levels and (current_level>highest_level) then
      error_txt ( 'Too many arguments' );
  which := which^.next_var;
 end;
 if (which <> nil)and(which^.name<>'')and not used_white_spaces and not call_levels then
  error_txt ( 'Too few arguments' );
 push_parameters := stack_correct;
end;

procedure compile_own_call ( s: string; need_a_result: boolean );
var func_name              : string;
    stack                  : word;
    act_proc               : ppascal_procedure;
    parameter_string       : string;
    temp_v		   : ppascal_var;
    i, k		   : word;
    temp_s		   : string;
    nr_bs		   : word;
    real_par		   : string;
    lib_str		   : pstringstream;
begin
 func_name := trim(copy (s, 1, str_pos('(', s)-1));
 parameter_string := trim(copy (s, str_pos ('(', s)+1, str_pos(')', s)-str_pos('(', s)-1));
 { Get library definition      -> should be in the procedure tree }
 if inline_class_object^.check_inline_func ( func_name, parameter_string, $FFFF ) then
  exit;
 act_proc := first_procedure;
 while (upper_str (act_proc^.name) <> upper_str ( func_name )) and (act_proc <> nil) do
  act_proc := act_proc^.next_procedure;
 if act_proc = nil then
   error_txt ('Unknown procedure, ...');
 act_proc^.used := true;
 if act_proc^.synonym <> '' then begin
  { -->> Insert synonymcode >>-- }
  real_par := parameter_string;
  func_name := copy ( act_proc^.synonym , 1, str_pos ( '(', act_proc^.synonym ) - 1 );
  parameter_string := copy ( act_proc^.synonym , length ( func_name ) + 2, 255);
  {delete ( parameter_string, length ( parameter_string ), 1 );}
  parameter_string := parameter_string + ',';
  temp_v := act_proc^.first_var;
  while (temp_v <> nil)and(temp_v^.name<>'') do begin
    i := 1;
    nr_bs := 0;
    repeat
     temp_s := copy ( parameter_string, i, search_start ( ',', parameter_string, i )-i);
     inc ( nr_bs );
     i := i + length(temp_s) + 1;
     delete ( temp_s, length(temp_s), 1);
     temp_s := trim ( temp_s );
    until (temp_s=temp_v^.name)or(i>length(parameter_string));
    if temp_s = temp_v^.name then begin
      { -->> Find position >>-- }
      i := 1;
      k := 1;
      while nr_bs <> i do begin
        if parameter_string[k] = ',' then inc ( i );
        inc ( k );
      end;
      delete ( parameter_string, k, search_start (',', parameter_string, k)-1);
      insert ( get_parameter ( real_par ), parameter_string, k);
    end;
    temp_v := temp_v^.next_var;
  end;
  if parameter_string [ length ( parameter_string ) ] = ',' then
   delete ( parameter_string, length(parameter_string), 1);
  compile_own_call ( func_name + '(' + parameter_string + ');', need_a_result );
  exit;
 end;
 output_commentbox('Calling a procedure');
 if str_pos ('::', func_name)>0 then
  output('  movem.l d0-d7/a0-a6,-(a7)');
 { First lock all needed registers }
 temp_v := act_proc^.first_var;
 while ( temp_v <> nil ) and ( temp_v^.name <> '' ) do begin
  if length(temp_v^.needed_register)=2 then set_registerstate ( temp_v^.needed_register, true );
  temp_v := temp_v^.next_var;
 end;
 { Push arguments onto the stack }
 stack := push_parameters ( parameter_string, act_proc^.first_var, true);
 while ( temp_v <> nil ) and ( temp_v^.name <> '' ) do begin
  if length(temp_v^.needed_register)=2 then set_registerstate ( temp_v^.needed_register, false );
  temp_v := temp_v^.next_var;
 end;
 if str_pos('::', func_name)>0 then begin
  { -->> Fargo I / Fargo II / 92+ calls >>-- }
  new ( lib_str, init );
  lib_str^.add_string ( trim (copy ( act_proc^.name, 1, pos ('::', act_proc^.name)-1)));
  lib_str^.add_string ( trim (copy ( act_proc^.name, pos ('::', act_proc^.name)+2, 255)));
  fargo_version_stream^.insert ( _librarycall, form_container_2, lib_str, temp_s );
  dispose ( lib_str, done );
  output ( temp_s )
 end else
  output('  bsr _'+lower_str(act_proc^.name));
 if stack>0 then
  output ('  lea '+conv_to_str ( stack ) + '(a7),a7');
 if need_a_result and (act_proc^.result_in='') then
  error_txt ('Function "' + act_proc^.name + '" has got no result');
 if not need_a_result then begin
  if (act_proc^.fkt_var<>nil)and(act_proc^.fkt_var^.size>4) then
   call_library ( 'paslib', 'MergeLast' );
 end;
 if need_a_result then
  if act_proc^.fkt_var^.size > 4 then inc ( func_lvl );
 if str_pos ('::', func_name)>0 then
  output('  movem.l (a7)+,d0-d7/a0-a6');
end;

begin
 func_lvl := 0;
end.