
{

 Optimizing system of Ultra Pascal

 created under the terms of       MXM Projects
                                  http://start.at/mxm

 created by                       MXM-TriX
                                  alexander.grutsch.htlr@schulen.vol.at

}

unit upas_opt;

interface

function optimize ( s: string ) : string;

implementation

uses upas_str;

type optimize_struc = record
        op_code         : string[20];
        reg_1_con       : string[10];
        reg_2_con       : string[10];
        leaveout         : boolean;
        other_op_code   : string[20];
     end;

const optimize_const: array[0..6]of optimize_struc =
((op_code: 'adda'; reg_1_con: '#0'; reg_2_con: ''; leaveout: true; other_op_code: ''),
 (op_code: 'move'; reg_1_con: '#0'; reg_2_con: ''; leaveout: false; other_op_code: 'clr'),
 (op_code: 'cmp'; reg_1_con: '#0'; reg_2_con: ''; leaveout: false; other_op_code: 'tst'),
 (op_code: 'muls'; reg_1_con: '#0'; reg_2_con: ''; leaveout: false; other_op_code: 'clr'),
 (op_code: 'link'; reg_1_con: '#0'; reg_2_con: ''; leaveout: true; other_op_code: ''),
 (op_code: 'add'; reg_1_con: '#0'; reg_2_con: ''; leaveout: true; other_op_code: ''),
 (op_code: 'move'; reg_1_con: '#-1'; reg_2_con: ''; leaveout: false; other_op_code: 'st'));


function optimize;
var i: word;
    op_code, reg_1_con, reg_2_con: string[50];
    op_size : string[4];
    tbool: boolean;
    output_str : string;
    to_optimize: string;
    suffix_str : string;
begin
output_str := '';
if pos(#13#10+';', s)=1 then begin
 optimize := s;
 exit;
end;
to_optimize := s+#13#10;
while pos(#13#10, to_optimize)>0 do begin
if output_str <> '' then output_str := output_str + #13#10;
suffix_str := '';
s := copy(to_optimize, 1, pos(#13#10, to_optimize)-1);
delete(to_optimize, 1, pos(#13#10, to_optimize)+1);
if (s[length(s)] = ':')or(s[1] = ';')or(pos('.', s)=0) then begin
 output_str := output_str + s;
 continue;
end;
if pos(';', s)>0 then begin
 suffix_str := copy(s, pos(';', s), 255);
 s := trim(copy(s, 1, pos(';', s)-1));
end;
op_code := trim(copy(s, 1, pos('.', s) - 1 ));
op_size := copy(s, pos('.', s)+1, 1);
reg_1_con := trim(copy(s, pos('.', s) + 2, pos(',', s) - pos('.', s) - 2));
reg_2_con := trim(copy(s, pos(',', s) + 1, 255));
for i:=0 to high(optimize_const) do begin
 tbool := false;
 if op_code = optimize_const[i].op_code then begin
  if (reg_1_con = optimize_const[i].reg_1_con)and(optimize_const[i].reg_1_con <> '') then
   tbool := true
  else
   tbool := false;
  if (reg_2_con = optimize_const[i].reg_2_con)and(optimize_const[i].reg_2_con <> '') then
   tbool := true
  else
   if (optimize_const[i].reg_2_con = '') and tbool then
    tbool:= true
   else
    tbool:= false;
 end;
 if tbool then begin
  if optimize_const[i].leaveout then begin
   output_str := output_str + '; Instruction isn''t necessary: '+s;
   break;
  end else begin
   output_str := output_str + '; Optimized part:'+#13#10+'  '+optimize_const[i].other_op_code+'.'+op_size+' '+reg_2_con;
   break;
  end;
 end;
end;
if not tbool then output_str := output_str + s + suffix_str;
end;
optimize := output_str;
end;

end.