
{

 Stringhandlingroutines for Ultra Pascal

 released under the terms of      MXM Projects
                                  http://start.at/mxm

 created by                       MXM-TriX
                                  alexander.grutsch.htlr@schulen.vol.at

}

unit upas_str;

interface

function trim_right(s: string): string;
function trim_left(s: string): string;
function trim(s: string): string;
function lastword (s: string; c: char): string;
function str_pos (search: string; searchin: string): word;
function rep_str (s: string; count: word): string;
procedure swap_str ( var s1, s2: string);
function upper_str ( s: string ): string;
function lower_str ( s: string ): string;
function search_start ( substr, s: string; start: word ) : word;
function hexwrite (s: longint; maxlen: word; write_zeros: boolean): string;
function operand_pos ( op_name, search_in: string ): word;


implementation

function trim_right(s: string): string;
var i: word;
begin
i:=length(s);
while (s[i]=' ')or(s[i]=#9)and(i>0) do dec(i);
trim_right:=copy(s,1,i);
end;

function trim_left(s: string): string;
var i: word;
begin
i:=1;
while (s[i]=' ')or(s[i]=#9)and(i<=length(s)) do inc(i);
trim_left:=copy(s,i,255);
end;

function trim(s: string): string;
var c_s: string;
begin
c_s:=s;
c_s:=trim_left(c_s);
c_s:=trim_right(c_s);
trim:=c_s;
end;

function lastword (s: string; c: char): string;
var ps,rs: string;
    i: word;
begin
ps := trim (s);
i := length(ps);
if c in ['.',';'] then dec ( i );
rs := '';
while (ps[i]<>' ')and(i>0) do begin rs:=ps[i]+rs;dec(i); end;
lastword:=rs;
end;

function str_pos (search: string; searchin: string): word;
var re_str_pos: array[0..255]of byte;
    i: byte;
    buffer_string: string;
    in_str: boolean;
begin
{ Building of the buffer_string, leave out all strings }
re_str_pos[0] := 0;
in_str := false;
buffer_string := '';
for i := 1 to length(searchin) do begin
 case searchin[i] of
   '''': in_str := not in_str;
 end;
 if not in_str and (searchin[i]<>'''')then begin
  buffer_string := buffer_string + searchin[i];
  re_str_pos[length(buffer_string)] := i;
 end;
end;
str_pos := re_str_pos[pos(search, buffer_string)];
end;

function rep_str;
var out_str: string;
    i: word;
begin
out_str := '';
for i := 1 to count do
 out_str := out_str + s;
rep_str := out_str;
end;

procedure swap_str;
var temp: string;
begin
temp:=s2;
s2 := s1;
s1 := temp;
end;

function upper_str;
var output_str : string;
    i          : word;
begin
output_str := '';
for i := 1 to length(s) do output_str := output_str + upcase(s[i]);
upper_str := output_str;
end;

function lower_str;
var   i : word;
begin
for i:=1 to length(s) do
 case s[i] of
  'A'..'Z':  s[i] := char(ord(s[i]) + 32); { ord('a') - ord('A') }
 end;
lower_str := s;
end;

function search_start;
var x : word;
begin
 x := pos ( substr, copy ( s, start, 255 ));
 if x > 0 then
  search_start := x + start
 else
  search_start := 0;
end;

function hexwrite (s: longint; maxlen: word; write_zeros: boolean): string;
const hextab: array[0..$F] of char = '0123456789abcdef';
var out_str: string;
    i: word;
begin
out_str:='';
for i:=0 to 7 do begin
 out_str:=hextab[s and $F]+out_str;
 s:=s shr 4;
end;
if maxlen < length(out_str) then out_str := copy(out_str, length(out_str) - maxlen + 1, maxlen);
if not write_zeros then
 while out_str[1]='0' do delete(out_str, 1, 1);
hexwrite := out_str;
end;

function operand_pos ( op_name, search_in: string ): word;
var pos_array: array[0..255] of byte;
    i: word;
    rk: word;
    index: word;
    search_Str: string;
    instr: boolean;
begin
rk := 0; index := 1; search_str := ''; instr := false;
pos_array [ 0 ] := 0;
for i := 0 to length ( search_in ) do begin
  case search_in [ i ] of
    '''': instr := not instr;
    '(', '[': if not instr then inc ( rk );
    ')', ']': if not instr then dec ( rk );
  end;
  if rk = 0 then begin
   search_str := search_str + search_in[i];
   pos_array [ index ] := i;
   inc ( index );
  end;
end;
operand_pos := pos_array [pos ( op_name, search_str )];
end;

end.