{

 Support for the different Fargo versions for UltraPascal

 created by 	MXM-TriX		mxmtrix@hotmail.com
 					http://start.at/trix

 released by    MXM Projects		http://start.at/mxm

 Last update	17081998

}

unit upas_sys{tems};

interface

function get_label(which_queue: word): string;
procedure new_label(label_name: string; destination: word);

{ -->> Automatically compiling >>-- }
procedure put_file_to_compile ( s: string );
function get_file_to_compile ( seek: boolean ): string;

type events = (_librarycall, _asm_header, _asm_end,
                _library_header, _library_end, _lib_def_ext, _lib_def_line,
                _lib_export_definitions, _lib_export_proc, _loop, _stop,
		_error);

      dir_search = (_unitdirpath, _outputdirpath );

 const event_strings: array[_librarycall .. _lib_export_proc] of string[25] =
   ('library_call', 'program_header', 'program_end',
    'library_header', 'library_end', 'lib_def_ext', 'lib_def_line',
    'lib_export_definitions','lib_export_procedure');
       dir_strings: array[_unitdirpath .. _outputdirpath] of string[10] =
   ('UNIT', 'OUTPUT');

    { -->> Stringcontainer >>-- }
 type
      pinsert_return = ^tinsert_return;
      tinsert_return = record
         equ    : array[0..2] of string;
	 return : events;
      end;
      pstring_entry = ^tstring_entry;
      tstring_entry = record
         next : pstring_entry;
         str  : string[80];
      end;

      { -->> String container >>-- }
      pstringstream = ^tstringstream;
      tstringstream = object
        constructor init;
        destructor done; virtual;
        procedure add_string ( s: string ); virtual;
	procedure stream_seek ( pos: word ); virtual;
        function get_string : string; virtual;
      private
        curr        : pstring_entry;
        prv_str_tbl : pstring_entry;
      end;

      pevent_entry = ^tevent_entry;
      tevent_entry = record
         event_obj : pstringstream;
         next_event_entry: pevent_entry;
      end;

      { -->> Fargo System container >>-- }
      pfargo_system = ^tfargo_system;
      tfargo_system = object
        constructor init ( version: string; table_file: string );
        destructor done; virtual;
        function insert ( event: events; format_obj, instream_obj: pstringstream;
	                  var out_s: string): events; virtual;
        function get_event_str ( event: events ): string; virtual;
       private
        event_table : pevent_entry;
       public
        equ_tbl : pinsert_return;
      end;

      { -->> File container >>-- }
      pupasfile = ^upasfile;
      upasfile = object
           constructor init ( filename : string );
           destructor done; virtual;
           function search_file ( ds: dir_search; filename: string ): string; virtual;
           function getpathname ( ev: dir_search ): string;
      private
           directories: array[_unitdirpath .. _outputdirpath] of PChar;
      end;


implementation

uses printf, upas_str, upas_def, strings, windos;

constructor tstringstream.init;
begin
 new ( prv_str_tbl );
 curr := prv_str_tbl;
 curr^.next := nil;
end;

destructor tstringstream.done;
var _curr, nxt: pstring_entry;
begin
_curr := prv_str_tbl;
while _curr <> nil do begin
 nxt := _curr^.next;
 dispose ( _curr );
 _curr := nxt;
end;
end;

procedure tstringstream.add_string;
begin
 curr^.str := s;
 if curr^.next = nil then begin
  new ( curr^.next );
  curr^.next^.next := nil;
  curr^.next^.str := '';
 end;
 curr := curr^.next;
end;

procedure tstringstream.stream_seek;
var i: word;
begin
 curr := prv_str_tbl;
 i := 1;
 while i <> pos do begin
  curr := curr^.next;
  inc ( i );
 end;
end;

function tstringstream.get_string;
begin
 if curr <> nil then begin
  get_string := curr^.str;
  curr := curr^.next;
 end else
  get_string := '';
end;

function read_tbl_line ( var t: text ): string;
var s: string;
begin
while true do begin
   readln ( t, s );
   if s = '/*' then begin
    while s <> '*/' do readln ( t, s );
    continue;
   end;
   if copy ( s, 1, 2 ) = '//' then continue;
   if s <> '' then break;
end;
 read_tbl_line := s;
end;

constructor tfargo_system.init;
var Fargo_Ident: string;
    s : string;
    t : text;
    current_entry : pevent_entry;
    current_str   : pstring_entry;
begin
 new ( equ_tbl );

 Fargo_Ident := version+':';

 new ( event_table );
 current_entry := event_table;

 assign ( t, table_file );
 reset ( t );

 while not eof ( t ) do begin
   { New event }
   s := read_tbl_line ( t );
   if copy ( s, 1, 3 ) = 'END' then break;

   new ( current_entry^.event_obj, init );
   current_entry^.event_obj^.add_string ( trim ( s ) );
   while copy ( s, 1, 10 ) <> Fargo_Ident do s := read_tbl_line ( t );
   s := read_tbl_line ( t );
   while (copy ( s, 1, 2 ) <> '__')and(copy ( s, 1, 3 ) <> 'END') do begin
    current_entry^.event_obj^.add_string ( trim ( s ));
    s := read_tbl_line ( t );
   end;
   current_entry^.event_obj^.add_string ( 'END' );
   if copy ( s, 1, 3 ) <> 'END' then
    while copy ( s, 1, 3 ) <> 'END' do s := read_tbl_line ( t );
   new ( current_entry^.next_event_entry );
   current_entry := current_entry^.next_event_entry ;
   current_entry^.next_event_entry := nil;
 end;
 close ( t );
end;

destructor tfargo_system.done;
var current_entry, next	: pevent_entry;
    current_str, prev   : pstring_entry;
begin
 current_entry := event_table;
 while current_entry^.next_event_entry <> nil do begin
  dispose ( current_entry^.event_obj, done);
  next := current_entry^.next_event_entry;
  dispose ( current_entry );
  current_entry := next;
 end;
 dispose ( current_entry );
 dispose ( equ_tbl );
end;

function tfargo_system.insert;
var current_entry: pevent_entry;
    current_str  : string;
    form_str     : array[0..6*2-1] of string;
    i, count	 : word;
    s		 : string;
    pos		 : word;
    temp_s	 : string;
begin
 format_obj^.stream_seek ( 1 );
 out_s := '';
 count := 1;
 for i := 0 to 6*2-1 do form_str [ i ] := '';
 while true do begin
  s := format_obj^.get_string;
  if s = '' then break;
  form_str[2*(count-1)] := s;
  inc ( count );
 end;
 form_str [ 2 * count ] := '';
 { Search evententry }
 current_entry := event_table;
 current_entry^.event_obj^.stream_seek ( 1 );
 while (current_entry^.event_obj^.get_string <> '__' + event_strings[event] + ':') do begin
  current_entry := current_entry^.next_event_entry;
  current_entry^.event_obj^.stream_seek ( 1 );
 end;
 { Do inserting }
 current_str := current_entry^.event_obj^.get_string;
 pos := 1;
 while current_str <> 'END' do begin
  if copy ( current_str, 1, 2 ) = 'DO' then begin
   { Inserting, until end }
   pos := 1;
   while true do begin
    for i := 1 to count-1 do begin
     instream_obj^.stream_seek ( pos );
     form_str [ 2 * (i-1) + 1] := instream_obj^.get_string;
     inc ( pos );
    end;
    temp_s := insert_string ( copy (current_str, 3, 255), form_str ) + #13#10;
    if not (temp_s[1] in [' ',';']) then temp_s := '  ' + temp_s;
    out_s := out_s + temp_s;
    instream_obj^.stream_seek ( pos );
    if instream_obj^.get_string = '' then break;
   end;
  end else begin
    for i := 1 to count do begin
     instream_obj^.stream_seek ( pos );
     form_str [ 2 * (i-1) + 1] := instream_obj^.get_string;
     inc ( pos );
    end;
    temp_s := insert_string ( current_str, form_str ) + #13#10;
    if not (temp_s[1] in [';',' ']) then temp_s := '  ' + temp_s;
    out_s := out_s + temp_s;
  end;
  current_str := current_entry^.event_obj^.get_string;
 end;
 delete ( out_s, length(out_s)-1, 2);
end;

function tfargo_system.get_event_str;
var current_entry: pevent_entry;
    s : string;
    pos : word;
begin
 s := '';
 current_entry := event_table;
 current_entry^.event_obj^.stream_seek ( 1 );
 while current_entry^.event_obj^.get_string <> '__' + event_strings[event] + ':' do begin
  current_entry := current_entry^.next_event_entry;
  current_entry^.event_obj^.stream_seek ( 1 );
 end;
 pos := 2;
 repeat
  current_entry^.event_obj^.stream_seek ( pos );
  s := s + '  ' + current_entry^.event_obj^.get_string + #13#10;
  inc ( pos );
 until current_entry^.event_obj^.get_string = 'END';
 delete ( s, length(s)-1, 2);
 get_event_str := s;
end;

{ -->> Label handling >>-- }

type t_labels = array[0..1] of record
         names: array[0..49]of string[40];
         current_index: word;
         counter: word;
     end;
     pt_labels = ^t_labels;

var labels: pt_labels;

procedure new_label(label_name: string; destination: word);
var i: word;
    prev_str : string;
begin
if labels = nil then begin
 new(labels);
 for i:=0 to high ( t_labels ) do begin
  labels^[i].counter:=0;
  labels^[i].current_index:=0;
 end;
end;
inc(labels^[destination].counter);
if unit_compile then
 prev_str := unit_name + '_'
else
 prev_str := '';
 labels^[destination].names[labels^[destination].current_index] :=
prev_str + label_name+'_'+hexwrite(labels^[destination].counter, 4, true);
inc(labels^[destination].current_index);
end;

function get_label(which_queue: word): string;
begin
if labels^[which_queue].current_index=0 then
 get_label:=''
else begin
 get_label := labels^[which_queue].names[labels^[which_queue].current_index-1];
 dec (labels^[which_queue].current_index);
end;
end;

{ -->> UltraPascal FileSearch object >>-- }

constructor upasfile.init;
var t: text;
    w: dir_search;
    s: string;
    i: word;
    tmp_s: string;
    p: PChar;
begin
 assign ( t, filename );
 getmem ( p, $100 );
 reset ( t );
  w := low ( dir_search );
 while not eof ( t ) do begin
   repeat
    s := read_tbl_line ( t );
   until pos (dir_strings [ w ]+':', s)>0;
   getmem ( directories [ w ], $100);
   s := trim (copy ( s, length ( dir_strings [ w ] ) + 2, 255 ));
   { -->> Insert enivronmentvariables >>-- }
   i := 1;
   while i <= length ( s ) do begin
    while (s[i] <> '%')and(i<=length(s)) do inc ( i );
    if s[i] = '%' then begin
     tmp_s := copy ( s, i+1, 255 );
     tmp_s := copy ( tmp_s, 1, pos ('%', tmp_s)-1);
     delete ( s, i, length ( tmp_s )+2 );
     StrPCopy ( p, trim (tmp_s));
     tmp_s := StrPas ( getenvvar ( p ));
     insert ( tmp_s, s, i );
    end;
   end;
   StrPCopy ( directories [ w ], s );
   w := Succ ( w );
   if w > high ( dir_strings ) then break;
 end;
 close ( t );
end;

destructor upasfile.done;
begin
end;

function upasfile.search_file;
var p, p2: PChar;
begin
getmem ( p, $100 );
getmem ( p2, $100 );
StrPCopy ( p2, filename );
FileSearch ( p, p2, directories [ ds ]);
search_file := StrPas ( p );
freemem ( p2, $100 );
freemem ( p, $100 );
end;

function upasfile.getpathname;
begin
 getpathname := StrPas ( directories [ ev ] );
end;

var compile_position : word;
    compile_file_queue : array [ 1 .. 19 ] of string [ 80 ];

procedure put_file_to_compile ( s: string );
begin
 inc ( compile_position );
 compile_file_queue [ compile_position ] := s;
end;

function get_file_to_compile;
begin
 if compile_position > 0 then begin
  get_file_to_compile := compile_file_queue [ compile_position ];
  if seek then dec ( compile_position );
 end else
  get_file_to_compile := '';
end;

begin
 compile_position := 0;
end.