
{

 Reading of an UltraPascal unit / creating of an UltraPascal unit

 created by MXM-TriX
 mxmtrix@xoommail.com

 created under the terms of MXM Projects
 http://start.at/mxm

}

unit upas_uni{t};

interface

uses upas_def, strings, upas_str, upas_ch;

type      unit_events = (_toggle, _new_procedure, _new_variable, _end_unit,
			 _parameter_term, _asm_code, _preprocessor_code,
			 _synonym_def, _used_unit, _new_type);

const chunk_sizes: array[_toggle .. _new_type ]of word =
              ( 0, sizeof ( pascal_procedure ), sizeof ( pascal_var ), $FFFF,
                0, $FFFD, $FFFE, sizeof ( pascal_procedure ), sizeof ( str10 ), sizeof ( pascal_var ));

var interface_compile  : boolean;
    last_proc	       : ppascal_procedure;
    used_proc	       : ppascal_procedure;
    unit_file	       : pcache;

procedure create_unit_file ( name: string; libdef: boolean; unitname: string; fargo_version: byte);
procedure close_unit_file;
procedure write_pascal_var ( ppvar: ppascal_var; rec_call: boolean );
procedure write_pascal_procedure ( ppvar: ppascal_procedure );
procedure open_pascal_proc_code ( proc_name: ppascal_procedure );
procedure close_pascal_proc_code;
procedure unit_pascal_code_output (what: string);
procedure implementation_start;
procedure interface_start;
procedure libdef_start;
procedure write_synonym_def ( p: ppascal_procedure );
procedure read_synonym_def ( first : ppascal_procedure );
procedure write_used_unit ( s: str10 );
function read_used_unit: string;
function open_unit ( name : string ): boolean;
function read_next_event : unit_events;
function read_unit_procedure ( var first, last: ppascal_procedure; read_new : boolean ): boolean;
function read_unit_var ( var first, last: ppascal_var; read_new : boolean ): boolean;
procedure close_opened_unit;
function get_unit_c: char;
function read_unit_line ( var s: string ): boolean;
procedure open_preprocessor_code ( s: string );
procedure read_open_proc_code;
procedure write_type_var ( ppvar: ppascal_var; reccall: boolean );
function read_type_var ( var first, last: ppascal_var; read_new: boolean ): boolean;


implementation

const header: array[0..24]of char = 'UltraPascal File, V0.35'#13#10;
      lib_def_header 		: array[0..16]of char = 'Librarydefinition';
      unit_def_header		: array[0..7] of char = 'Unitfile';
      termination		: byte = $FF;
      line_termination		: byte = $FE;
      var_code			: byte = $90;
      proc_code			: byte = $91;
      lib_code			: byte = $92;
      interface_code		: byte = $93;
      implementation_code	: byte = $94;
      code_asm			: byte = $95;
      parameter_termination 	: byte = $96;
      preprocessor_code 	: byte = $97;
      syn_def_code      	: byte = $98;
      inc_unit_code		: byte = $99;
      type_code                 : byte = $9a;

var
    opened_files	: array[1..5] of record
                            f: pcache;
                            u_name: string;
                            real_fn: string;
                          end;
    in_file		: word;
    last_var 		: ppascal_var;
    u_name   		: string;


procedure new_handle ( s: string; b: boolean );
var temp_f : file;
begin
 inc ( in_file );
 new ( opened_files [ in_file ].f, init ( s, b ));
 opened_files [ in_file ].real_fn := s;
 unit_file := opened_files[in_file].f;
end;

procedure create_unit_file;
var c: char;
begin
new_handle ( name, true );
unit_file^.cachewrite( header, sizeof(header));
if libdef then
 unit_file^.cachewrite(lib_def_header, sizeof(lib_def_header))
else
 unit_file^.cachewrite(unit_def_header, sizeof(unit_def_header));
unit_file^.cachewrite (NULL, sizeof(NULL));
while unitname <> '' do begin
 c := unitname[1];
 delete(unitname, 1, 1);
 unit_file^.cachewrite( c, 1);
end;
unit_file^.cachewrite (NULL, sizeof(NULL));
unit_file^.cachewrite (fargo_version, sizeof ( fargo_version ));
unit_file^.cachewrite (libdef, sizeof(boolean));
end;

procedure close_unit_file;
begin
 unit_file^.cachewrite (termination, sizeof(termination));
 dispose ( unit_file, done );
 dec ( in_file );
 if in_file>0 then begin
  unit_file := opened_files [ in_file ].f;
  u_name := opened_files [ in_file].u_name;
 end;
end;

procedure write_pascal_var;
var buffer_string : string;
    key           : longint;
    bo            : boolean;
    saved_strings : array[0..2]of string;
begin
 if ppvar^.name='' then exit;
 with ppvar^ do begin
   unit_file^.cachewrite ( var_code, sizeof(var_code));
   unit_file^.cachewrite ( ppvar^, sizeof(pascal_var));
   if record_first_var<>nil then
    write_pascal_var (record_first_var, true);
   if rec_call and (next_var <> nil) then
    write_pascal_var (next_var, true);
 end;
end;

procedure write_pascal_procedure;
begin
 unit_file^.cachewrite ( proc_code, sizeof(proc_code));
 unit_file^.cachewrite ( ppvar^, sizeof(pascal_procedure));
 if ppvar^.fkt_var <> nil then
   write_pascal_var ( ppvar^.fkt_var, false );
 write_pascal_var ( ppvar^.first_var, true);
 unit_file^.cachewrite ( parameter_termination, 1);
end;

procedure open_pascal_proc_code;
var buffer_string : string;
    key           : longint;
    bo            : boolean;
    saved_strings : array[0..2]of string;
begin
 unit_file^.cachewrite ( proc_code, sizeof(proc_code));
 unit_file^.cachewrite ( proc_name^, sizeof(pascal_procedure));
 unit_file^.cachewrite ( parameter_termination, sizeof(parameter_termination));
 unit_file^.cachewrite ( code_asm, sizeof(code_asm));
end;

procedure read_open_proc_code;
var temp: pascal_procedure;
    c: byte;
begin
 unit_file^.cacheread ( c, sizeof ( code_asm ));
 unit_file^.cacheread ( temp, sizeof ( pascal_procedure ));
 unit_file^.cacheread ( c, 1 );
 unit_file^.cacheread ( c, 1);
end;

procedure close_pascal_proc_code;
const pascal_term : byte = $FE;
begin
 unit_file^.cachewrite ( pascal_term, 1);
end;

procedure unit_pascal_code_output;
begin
what := what+#13#10;
unit_file^.cachewrite (what[1], length(what));
end;

procedure implementation_start;
begin
 unit_file^.cachewrite (implementation_code, 1);
end;

procedure interface_start;
begin
 unit_file^.cachewrite ( interface_code, 1);
end;

procedure libdef_start;
begin
 unit_file^.cachewrite (lib_code, 1);
end;

function open_unit;
var buffer: array[0..sizeof(header)-1] of char;
    i : word;
    my_c : char;
begin
new_handle ( name, false );

open_unit := true;

i := ioresult;
if i <> 0 then begin
 open_unit := false;
 exit;
end;

unit_file^.cacheread ( buffer, sizeof(buffer) );
for i := 0 to sizeof(buffer)-1 do
 if buffer[i] <> header[i] then break;

if buffer[i] <> header[i] then begin
 open_unit := false;
 exit;
end;

unit_file^.cacheread ( my_c, 1);
i := 2;
while true do begin
 if my_c = #0 then dec(i);
 if i = 0 then break;
 unit_file^.cacheread ( my_c, 1);
end;

 u_name := copy ( name, 1, pos('.', name)-1);
 i := length(u_name);
 while (u_name[i]<>'\')and(i>0) do dec(i);
 u_name := copy(u_name, i+1, 255);
 opened_files[in_file].u_name := u_name;
end;

function read_next_event;
var c: char;
    readed: word;
begin
 while true do begin
 unit_file^.cacheread (c, 1);
 case ord(c) of
   $90		: read_next_event := _new_variable;
   $91		: read_next_event := _new_procedure;
   $92		: continue;
   $93          : begin
                   interface_compile := true;
                   read_next_event := _toggle;
                  end;
   $94          : begin
                   interface_compile := false;
 		   read_next_event := _toggle;
                  end;
   $95		: read_next_event := _asm_code;
   $96		: read_next_event := _parameter_term;
   $97		: read_next_event := _preprocessor_code;
   $98		: read_next_event := _synonym_def;
   $99		: read_next_event := _used_unit;
   $9a          : read_next_event := _new_type;
   $FF  	: read_next_event := _end_unit;
 end;
 break;
 end;
end;

function read_unit_procedure;
var act: ppascal_procedure;
    c: char;
begin
 if read_new then begin
  if last_proc^.fkt_var <> nil then dispose ( last_proc^.fkt_var );
  last_proc^.fkt_var := nil;
  unit_file^.cacheread ( last_proc^, sizeof ( pascal_procedure ));
  if last_proc^.fkt_var <> nil then begin
   last_proc^.fkt_var := nil;
   unit_file^.cacheread(c,1);
   create_new_var ( last_proc^.fkt_var );
   read_unit_var ( last_proc^.fkt_var, last_proc^.fkt_var, true );
   read_unit_var ( last_proc^.fkt_var, last_proc^.fkt_var, false );
  end;
 end;
 act := first;
 if pos ( ':' , last_proc^.name )>0 then
  delete ( last_proc^.name, 1, pos (':', last_proc^.name));
 while (act <> nil) and (upper_str(act^.name) <> upper_str(last_proc^.name)) do
  act := act^.next_procedure;
 if (act <> nil) and (upper_str(act^.name) <> upper_str(last_proc^.name)) then
  read_unit_procedure := true
 else
  read_unit_procedure := false;
 used_proc := last;
 if lib_def then interface_compile := true;
 if not read_new then begin
  { Insert proceduredefinition in list }
  if not interface_compile and (upper_str('_'+u_name+'_main') <> upper_str(last_proc^.name)) then exit;
  last^ := last_proc^;
  last^.fkt_var := nil;
  if last_proc^.fkt_var <> nil then begin
   create_new_var ( last^.fkt_var );
   last^.fkt_var^ := last_proc^.fkt_var^;
  end;
  last^.next_procedure := nil;
 end;
end;

procedure record_read ( first: ppascal_var );
var c: char;
begin
 create_new_var ( first^.record_first_var );
 first := first^.record_first_var;
 repeat
  unit_file^.cacheread ( c, 1 );
  unit_file^.cacheread ( first^, sizeof ( pascal_var ));
  if (first^.next_var = nil)or(first^.name='') then break;
  if first^.variabelntyp = _record then
   record_read ( first );
  create_new_var ( first^.next_var );
  first := first^.next_var;
 until 1=2;
end;

function read_unit_var;
var act : ppascal_var;
    i   : word;
    c   : char;
begin
 if read_new then
   unit_file^.cacheread ( last_var^, sizeof ( pascal_var ));
 act := first;
 while (act <> nil) and (upper_str(act^.name) <> upper_str(last_proc^.name)) do
  act := act^.next_var;
 if (act <> nil) and (upper_str(act^.name) <> upper_str(last_proc^.name)) then
  read_unit_var := true
 else
  read_unit_var := false;
 if not read_new then begin
  { Insert proceduredefinition in list }
  last^ := last_var^;
  last^.next_var := nil;
  if (last^.variabelntyp = _record)and(last^.name<>'') then
    record_read ( last );
 end;
end;

procedure close_opened_unit;
begin

 dispose ( unit_file, done );
 dec ( in_file );
 if in_file>0 then begin
  unit_file := opened_files [ in_file ].f;
  u_name := opened_files[in_file].u_name;
 end;
end;

function get_unit_c : char;
var my_c: char;
begin
 unit_file^.cacheread ( my_c, 1);
 get_unit_c := my_c;
end;

function read_unit_line;
var c: char;
begin
 s := '';
 repeat
  unit_file^.cacheread ( c, 1);
  if (c <> #13)and(c <> #$FE) then s := s + c;
 until (c = #13) or (c = #$FE);
 if ( c = #13 ) then unit_file^.cacheread ( c, 1);
 if c = #$FE then
  read_unit_line := false
 else
  read_unit_line := true;
end;

procedure open_preprocessor_code;
const percent: char = '%';
begin
 unit_file^.cachewrite ( preprocessor_code, 1 );
 unit_file^.cachewrite ( percent, 1 );
 unit_file^.cachewrite ( s[1], length(s));
 unit_file^.cachewrite ( line_termination, 1 );
end;

procedure write_synonym_def;
begin
 unit_file^.cachewrite ( syn_def_code, 1 );
 unit_file^.cachewrite ( p^, sizeof ( pascal_procedure ));
end;

procedure read_synonym_def;
var temp : pascal_procedure;
    np   : ppascal_procedure;
    fv,lv: ppascal_var;
begin
 unit_file^.cacheread ( temp, sizeof ( pascal_procedure ));
 while (upper_str(temp.name)<>upper_str(first^.name)) do
  first := first^.next_procedure;
 fv := first^.first_var;
 lv := first^.last_var;
 np := first^.next_procedure;
 first^ := temp;
 first^.first_var := fv;
 first^.last_var := lv;
 first^.next_procedure := np;
end;

procedure write_used_unit;
begin
 unit_file^.cachewrite ( inc_unit_code, 1 );
 unit_file^.cachewrite ( s, sizeof ( s ));
end;

function read_used_unit;
var s: str10;
begin
 unit_file^.cacheread ( s, sizeof ( s ));
 read_used_unit := s;
end;

procedure write_type_var;
begin
 if ppvar^.name='' then exit;
 with ppvar^ do begin
   unit_file^.cachewrite ( type_code, sizeof(var_code));
   unit_file^.cachewrite ( ppvar^, sizeof(pascal_var));
   if record_first_var<>nil then
    write_type_var (record_first_var, true);
   if reccall and (next_var <> nil) then
    write_type_var (next_var, true);
 end;
end;

function read_type_var;
var act : ppascal_var;
    i   : word;
    c   : char;
begin
 if read_new then
   unit_file^.cacheread ( last_var^, sizeof ( pascal_var ));
 act := first;
 while (act <> nil) and (upper_str(act^.name) <> upper_str(last_proc^.name)) do
  act := act^.next_var;
 if (act <> nil) and (upper_str(act^.name) <> upper_str(last_proc^.name)) then
  read_type_var := true
 else
  read_type_var := false;
 if not read_new then begin
  { Insert proceduredefinition in list }
  last^ := last_var^;
  last^.next_var := nil;
 end;
 if last^.variabelntyp = _record then
   record_read ( last );
end;

begin
new ( last_proc );
last_proc^.fkt_var := nil;
new ( last_var );
in_file := 0;
unit_compile := false;
randomize;
end.
